/*
 * Created on Aug 11, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package seat;

import java.net.MalformedURLException;
import java.net.URL;

import org.eclipse.core.resources.IFile;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.util.Assert;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IEditorReference;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.internal.WorkbenchMessages;
import org.eclipse.ui.internal.dialogs.DialogUtil;
import org.eclipse.ui.part.FileEditorInput;
import org.eclipse.ui.part.ViewPart;

import seat.model.core.dynamic.Trace;
import seat.ui.tree.ITraceEditor;
import seat.ui.views.StatisView;

/**
 * Gets the settings from prefernce store.  
 * This class consists mainly of static methods to get preference setting of this plugin.
 * @author lfu
 */
public class SeatUtil {
	public static final String VIEW_EXPLORATION="seat.ui.views.ExplorationView";
	public static final String VIEW_TREEVIEWER="seat.ui.views.TreeView";
	public static final String VIEW_CONTROLPANEL="seat.ui.views.ControlPanelView";
	public static final String VIEW_CALLER="seat.ui.views.CallerView";
	public static final String VIEW_PATTERN="seat.ui.views.PatternView";
	public static final String VIEW_UTILITY="seat.ui.views.UtilityView";

	public static final String ALGORITHM_EXTENSION_POINT="seat.algorithm";
	public static final int RESERVED_ALGIDX_UNSPECIFY=0;
	public static final int RESERVED_ALGIDX_FILTER=1;
	public static final int RESERVED_ALGIDX_UTILITY=2;
	public static final int RESERVED_ALGIDX_3=3;
	public static final int RESERVED_ALGIDX_4=4;

	public static final int TRACE_C=1;
	public static final int TRACE_JAVA=2;
	public static final int TRACE_OO=3;
	public static final int TRACE_ROUTINE=4;

	public static final int COLOR_PATTERN=0;
	public static final int COLOR_UTILITY=1;
	
	public static final String TRACE_DIRECTORY="trace.defaultdir";
	public static final String TRACE_TMP_DIRECTORY="trace.tmpdir";
	public static final String TRACE_COMPRESS="trace.compress";
	public static final String TRACE_COMPILER="trace.compiler";
	public static final String TRACE_SHOWFILTERED="trace.showfiltered";
	public static final String TRACE_ICON="trace.iconmatrix";
	public static final String TRACE_UTILITY_HIDE="trace.utility.hide";
	public static final String TRACE_UTILITY_METHODLIST="trace.utility.methodlist";
	public static final String TRACE_LONG_DECORATION="trace.utility.long_decoration";
	public static final String TRACE_DECORATION="trace.utility.decoration";
	public static final String TRACE_HIDDEN_FLAG="trace.utility.hiddenflag";
	public static final String TRACE_ENABLED_DECORATORS="ENABLED_DECORATORS";
	
	
	public static final String TRACE_ICON_ROOT="trace.icon.root";
	public static final String TRACE_ICON_CONTROL="trace.icon.control";
	public static final String TRACE_ICON_UITILITY="trace.icon.utility";
	public static final String TRACE_ICON_PATTERN="trace.icon.pattern";
	public static final String TRACE_ICON_PACKAGE="trace.icon.package";
	public static final String TRACE_ICON_CLASS="trace.icon.class";
	public static final String TRACE_ICON_METHOD="trace.icon.method";
	public static final String TRACE_ICON_FILE="trace.icon.file";
	public static final String TRACE_ICON_ROUTINE="trace.icon.routine";
	public static final String TRACE_ICON_SUBSYSTEM="trace.icon.subsystem";

	
	public static final String PROPERTY_TRACE_NODES="seat.property.trace_nodes";	
	public static final String PROPERTY_TRACE_GRAPH="seat.property.trace_graph";	
	public static final String PROPERTY_TRACE_COMPRESSED="seat.property.trace_compressed";	
	public static final String PROPERTY_TRACE_LOADTIME="seat.property.trace_loadtime";	
	public static final String PROPERTY_TRACE_PATTERNS="seat.property.trace_patterns";	
	public static final String PROPERTY_TRACE_SOURCE="seat.property.trace_source";	
	public static final String PROPERTY_TRACE_TYPE="seat.property.trace_type";	
	public static final String PROPERTY_TRACE_PACKAGE="seat.property.trace_package";	
	public static final String PROPERTY_TRACE_CLASS="seat.property.trace_class";	

	public static final String PROPERTY_NAME="seat.property.method_name";
	public static final String PROPERTY_FULLNAME="seat.property.method_fullname";
	public static final String PROPERTY_TYPE="seat.property.method_type";
	public static final String PROPERTY_NPARENTS="seat.property.nparents_type";
	public static final String PROPERTY_NCHILDREN="seat.property.nchildren";
	public static final String PROPERTY_SCOPE="seat.property.method_scope";
	public static final String PROPERTY_PARENT="seat.property.method_parent";
	public static final String PROPERTY_CHILDREN="seat.property.method_children";
	public static final String PROPERTY_LEVEL="seat.property.method_level";		
	public static final String PROPERTY_DESCRIPTION="seat.property.method_decription";
	
	public static final int METHOD_IMAGE_WIDTH=25;		
	public static final int METHOD_TEXT_WIDTH=100;		
	public static final int METHOD_BAR_WIDTH=13;

	public static final int IMG_DEFAULT=0;
	public static final int IMG_ROOT=1;
	public static final int IMG_CLASS=2;
	public static final int IMG_METHOD=3;
	public static final int IMG_UTILITY=4;
	public static final int IMG_PATTERN=5;
	public static final int IMG_UTILITY_PATTERN=6;
	public static final int IMG_FILTERED=7;
	public static final int IMG_REPETITION=8;
	public static final int IMG_ALGORITHM1=101;
	public static final int IMG_ALGORITHM2=102;
	public static final int IMG_ALGORITHM3=103;
	public static final int IMG_ALGORITHM4=104;
	public static final int IMG_ALGORITHM5=105;
	public static final int IMG_ALGORITHM6=106;
	public static final int IMG_ALGORITHM7=107;
	public static final int IMG_ALGORITHM8=108;
	public static final int IMG_ALGORITHM9=109;
	public static final int IMG_ALGORITHM10=110;
	
	
	
	/** 
	 * Returns the preference store of SEAT plugin
	 * @return IPreferenceStore
	 */
	public static IPreferenceStore getPluginPreferenceStore() {
		return SeatPlugin.getDefault().getPreferenceStore();
	}
	
	/**
	 * Returns the system default path where trace file will be loaded and saved 
	 * @return String, path
	 */
	public static String getDefaultTracePath() {
		 return getPluginPreferenceStore().getString(SeatUtil.TRACE_DIRECTORY);
	}

	/**
	 * Returns the temporary path where trace file will be saved 
	 * @return String, path
	 */
//	public static String getTemporaryTracePath() {
//		return getPluginPreferenceStore().getString(SeatUtil.TRACE_NONAME);		 
//	}

	public static String getStringSetting(String id) {
		 return getPluginPreferenceStore().getString(id);
	}
	public static String getDefaultSetting(String id) {
		 return getPluginPreferenceStore().getDefaultString(id);
	}
	public static boolean getBooleanSetting(String id) {
		 return getPluginPreferenceStore().getBoolean(id);
	}
	
	public static void addToUtilityDepot(String methodFullName) {
		IPreferenceStore store=getPluginPreferenceStore();
		String utilityString=(String)store.getString(SeatUtil.TRACE_UTILITY_METHODLIST);
		int index=utilityString.indexOf(methodFullName);
		if (index==-1)
			utilityString+=methodFullName+ ";";
		Assert.isNotNull(utilityString);
		store.setValue(SeatUtil.TRACE_UTILITY_METHODLIST, utilityString);
	}
	
	public final static String TRACE_NULL="_~null";
	public final static String TRACE_INACTIVE="_~inactive";
	public final static String TRACE_NONAME="_~noname";
	public final static String SPACE_SEPARATOR="#";

	/**
	 * Returns the ImageDescriptor by a file name. The image file is assumed to 
	 * locate in the icons subdirectory. User needs specify: "icons/"+ gif name
	 * @param name - image file name
	 * @return ImageDescriptor used to createe real Image
	 */	
	public static ImageDescriptor getImageDescriptor(String name) {
		String iconPath = "";
		try {
			URL installURL = SeatPlugin.getDefault().getDescriptor().getInstallURL();
			URL url = new URL(installURL, iconPath + name);
			return ImageDescriptor.createFromURL(url);
		} catch (MalformedURLException e) {
			// should not happen
			return ImageDescriptor.getMissingImageDescriptor();
		}
	}

	/**
	 * Returns the workbench shell.
	 * @return top level workbench shell
	 */
	public static Shell getWorkbenchShell() {
		return PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();
	}
	
	/**
	 * Finds the given view by its view id. 
	 * @param viewId- A string id of view to be found.
	 * @return ViewPart that stands for a view.
	 */
	public static ViewPart getView(String viewId) {
		return (ViewPart)PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().findView(viewId);
	}

	/**
	 * Finds the given editor by its editor id. 
	 * @param viewId- A string id of editor to be found.
	 * @return ViewPart that stands for a view.
	 */
	public static IEditorPart getEditor(Trace byTrace) {
		IEditorReference[] refer=PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getEditorReferences();
		Trace contained=null;
		for (int i=0;i<refer.length;i++) {
			IEditorPart edit=refer[i].getEditor(true);
			if (edit instanceof ITraceEditor) {
				contained=((ITraceEditor)edit).getTrace();
				if (contained==byTrace)
					return edit;
			}
		}
		return null;
	}


	public static IEditorPart getActiveEditor() {
		if (PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage()==null)
			return null;
		else
			return PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getActiveEditor();
	}
	
	public static IEditorPart getOpenedEditor() {
		IWorkbenchWindow[] windows=PlatformUI.getWorkbench().getWorkbenchWindows();
		if ((windows!=null)&&windows.length>0) {
			if (windows[0].getActivePage()==null)
				return null;
			else 
				return windows[0].getActivePage().getActiveEditor();
		}
		return null;
	}

	public static void openTraceEditor(IFile file) {
		IWorkbenchPage active=PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
		if (active==null) return;
		try {
			active.openEditor(new FileEditorInput(file),"seat.ui.tree.partial.PartialTreeEditor");
		} catch (PartInitException e) {
			DialogUtil.openError(
			PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(),
				WorkbenchMessages.getString("OpenSystemEditorAction.dialogTitle"), //$NON-NLS-1$
				e.getMessage(),
				e);
		}
	}

	public static IViewPart findOpenedView(String id) {
		IWorkbenchWindow[] windows=PlatformUI.getWorkbench().getWorkbenchWindows();
		if ((windows!=null)&&windows.length>0) {
			IWorkbenchPage active;
			if (windows[0].getActivePage()==null)
				return null;
			else { 
				active=windows[0].getActivePage();
				if (active==null) return null;
				IViewPart f=active.findView(id);
				if (f!=null) return f;
		 
				try {
					f=active.showView(id);
				} catch (PartInitException pie) {
					return null;
				}
				return f;
			}
		}
		return null;
	}		

	public static IViewPart findView(String id) {
		IWorkbenchPage active=PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();		
		if (active==null) return null;
		IViewPart f=active.findView(id);
		return f;  
		// there is bug that: An editor is opened, then its filter view is closed, close workbench,.
		// during the restore of workebench, the showview will not work properly, a null exception will be
		// in perspectivepresentation. Therefore, mark these lines, so the filterview will only be created 
		// by user.
//		if (f!=null) return f;
//		 
//		try {
//			f=active.showView(id);
//		} catch (PartInitException pie) {
//			return null;
//		}
//		return f;
	}		

	public static IViewPart findViewIfOpened(String id) {
		IWorkbenchPage active=PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();		
		if (active==null) return null;
		return active.findView(id);
	}	

	public static void refreshStatisViewIfOpened() {		
		StatisView statis=(StatisView)SeatUtil.findView("seat.ui.views.StatisView");		
		if (statis!=null) {
			statis.refresh();
		}
	}					
					
	
	
	public static void hideView(String id) {
		IWorkbenchPage active=PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();		
		if (active==null) return ;
		IViewPart f=active.findView(id);
		if (f==null) return ; // not there
		active.hideView(f);
	}		
	/**
	 * Finds the first selected object that exists in the primary Viewer UI control. 
	 * This method requires that the ViewPart implements IViewer.
	 * @param viewId- view id
	 * @return first selection, or null if there is no Viewer control.
	 */
	
//	public static Viewer getViewer(String viewId) {
//		ViewPart view=ViewHelper.getView(viewId);		
//		if (view instanceof IViewer) { 
//			Viewer primaryCtrl=((IViewer)view).getViewer();
//			return primaryCtrl;
//		}
//		else 
//			return null;
//	}	
//	
//	public static Object getFirstSelection(String viewId) {
//		ViewPart view=ViewHelper.getView(viewId);		
//		if (view instanceof IViewer) { 
//			Viewer primaryCtrl=((IViewer)view).getViewer();
//			IStructuredSelection selection=(IStructuredSelection)primaryCtrl.getSelection();
//			return selection.getFirstElement();
//		}
//		else 
//			return null;
//	}
//
//	/**
//	 * Returns all the selections in the given view id in an Iterator method.
//	 * This method requires that the ViewPart implements IViewer.
//	 * @param viewId
//	 * @return Iterator for the selection, or null if there is no Viewer control.
//	 */
//	public static Iterator getSelections(String viewId) {
//		ViewPart view=ViewHelper.getView(viewId);		
//		if (view instanceof IViewer) { 
//			Viewer primaryCtrl=((IViewer)view).getViewer();
//			IStructuredSelection selection=(IStructuredSelection)primaryCtrl.getSelection();
//			return selection.iterator();
//		}
//		else 
//			return null;
//	}

	/**
	 * Creates a string from a String array,separated by ';'.
	 * @param items- String array.
	 * @return -Contacted string.  
	 */
	public static String createListString(String[] items) {
		StringBuffer path = new StringBuffer("");
	
		for (int i = 0; i < items.length; i++) {
			path.append(items[i]);
			path.append(";");
		}
		return path.toString();
	}

	/**
	 * conveniece method for displaying a message
	 * @param message-string to be displayed
	 */
	public static void showMessage(String message) {
		MessageDialog.openInformation(null,"Message Window",message);
	}


}
