/*****************************************************************
 * Tool: SEAT - Software Exploration and Analysis Tool			 *
 *																 *
 * Class: TraceLoader.java										 *	
 * Package: io										 			 *
 *																 *
 * Author: Abdelwahab Hamou-Lhadj								 *
 *																 *	
 * Affiliation: Knowledge Based Reverse Engineering Group		 *
 *				SITE - University of Ottawa						 *
 *																 *
 * Version: 1.0 - July 2003										 *
 * 																 *
 * Modifications: 												 *
 * (please add date of modifications, author, short description  *
 *  after this line) 											 *	
 *																 *
 *****************************************************************/
 
package seat.io;

import java.io.IOException;

import seat.model.core.dynamic.Trace;

public abstract class TraceLoader
{
  protected Trace trace;	// The trace to be loaded
 
  /** Creates a trace loader
   *
   * @param trace the trace to load
   *
   */
    
  public TraceLoader(Trace trace)
  {
  	 this.trace	= trace;
  }
  
  /** Loads a trace into memory, to be overloaded by subclasses. */

  public abstract void open() throws IOException;
  
}