/*
 * Created on May 6, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package seat.io;

import java.util.ArrayList;
import java.util.Hashtable;

import org.eclipse.core.resources.IProject;

import seat.SeatUtil;
import seat.model.core.dynamic.Node;
import seat.model.core.dynamic.Trace;
import seat.model.core.dynamic.TreeTrace;
import seat.ui.algorithm.AlgorithmList;

/**
 * @author lfu
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class TraceState {
	private Trace trace;
	private float loadTime;  //in seconds
	private int type;
	private ITraceSource source;   // Trace source file
	private AlgorithmList algorithms;
	
	private int graphSize=0;
	private int treeNodes=0;
	private int compressedNodes=0;
	private int detectedPatterns=0;

	private ArrayList packageList=new ArrayList();  // constructed thru parsing, not sorted
	private ArrayList classList=new ArrayList();    // not sorted
	private ArrayList nodeFinalList=new ArrayList(); //sorted by name

	
	private ArrayList utilityList=new ArrayList();  // temporialy hold fro each editor, no other place to put
	private ArrayList patternList=new ArrayList();
	private ArrayList nodeList=new ArrayList();
	private ArrayList filteredNodeList=new ArrayList();

	private IProject[] srcProjects; // where source code located 
	private IProject  activeProject; // current project when arcProjects are not enough
	private Hashtable javaClasses=new Hashtable();  // for JavaElements from java core parsing
	/**
	 * 
	 */
	public TraceState(Trace trace) {
		this.trace=trace;
		loadTime=0.0f;
		type=SeatUtil.TRACE_C;
		algorithms=new AlgorithmList();
		source=null;
	}


	/**
	 * @return
	 */
	public AlgorithmList getAlgorithmList() {
		return algorithms;
	}

	/**
	 * @return
	 */
	public int getCompressedNodes() {
		compressedNodes=0;
		for (int i=0;i<nodeFinalList.size();i++) {
			Node node=(Node)nodeFinalList.get(i);
			if (node.isHidden()) 
				compressedNodes+=countNodes(node);
		}
		return compressedNodes;
	}
	

	/**
	 * @return
	 */
	public int getDetectedPatterns() {
		return detectedPatterns;
	}

	/**
	 * @return
	 */
	public int getGraphSize() {
		return graphSize;
	}

	/**
	 * @return
	 */
	public float getLoadTime() {
		return loadTime;
	}

	/**
	 * @return
	 */
	public ITraceSource getSource() {
		return source;
	}

	/**
	 * @return
	 */
	public int getTreeNodes() {
		treeNodes=0;
		for (int i=0;i<nodeFinalList.size();i++) {
			Node node=(Node)nodeFinalList.get(i);
			treeNodes+=countNodes(node);
		}
		return treeNodes;
	}

	/**
	 * @return
	 */
	public int getType() {
		return type;
	}

//	/**
//	 * @param i
//	 */
//	public void setCompressedNodes(int i) {
//		compressedNodes = i;
//	}

	/**
	 * @param i
	 */
	// set in DetectPattern.apply/undo method
	public void setDetectedPatterns(int i) {
		detectedPatterns = i;
	}

	/**
	 * @param i
	 */
	// set in trace.open(); 
	public void setGraphSize(int i) {
		graphSize = i;
	}

	/**
	 * @param f
	 */
	// set in trace.open(); 
	public void setLoadTime(float f) {
		loadTime = f;
	}

	/**
	 * @param source
	 */
	// set in trace constructor
	public void setSource(ITraceSource source) {
		this.source = source;
	}

	/**
	 * @param i
	 */
//	// set in trace.open(); 
//	public void setTreeNodes(int i) {
//		treeNodes = i;
//	}

	/**
	 * @param i
	 */
	public void setType(int i) {
		type = i;
	}

	/**
	 * @return
	 */
	public ArrayList getPatternList() {
		return patternList;
	}

	/**
	 * @return
	 */
	public ArrayList getUtilityList() {
		return utilityList;
	}
	
	/**
	 * @return
	 */
	public ArrayList getFilteredNodeList() {
		return filteredNodeList;
	}

	/**
	 * @return
	 */
	public ArrayList getNodeList() {
		return nodeList;
	}

	/**
	 * @return
	 */
	public ArrayList getPackageList() {
		return packageList;
	}

	/**
	 * @return
	 */
	public ArrayList getClassList() {
		return classList;
	}
	

//	/**
//	 * @param list
//	 */
//	public void setPatternList(ArrayList list) {
//		patternList = list;
//	}
//
//	/**
//	 * @param list
//	 */
//	public void setUtilityList(ArrayList list) {
//		utilityList = list;
//	}

	/**
	 * @return
	 */
	public AlgorithmList getAlgorithms() {
		return algorithms;
	}

	/**
	 * @return
	 */
	public IProject[] getProjects() {
		return srcProjects;
	}

	/**
	 * @param list
	 */
	public void setAlgorithms(AlgorithmList list) {
		algorithms = list;
	}

	/**
	 * @param projects
	 */
	public void setProjects(IProject[] projects) {
		srcProjects = projects;
	}

	/**
	 * @return
	 */
	public ArrayList getNodeFinalList() {
		return nodeFinalList;
	}

	/**
	 * @param list
	 */
	public void setNodeFinalList(ArrayList list) {
		nodeFinalList = list;
	}

	/**
	 * @return
	 */
	public IProject getActiveProject() {
		return activeProject;
	}

	/**
	 * @param project
	 */
	public void setActiveProject(IProject project) {
		activeProject = project;
	}

	// count from this up to parent
	private int countNodes(Node node) {
		int counter=0;
		for (int i=0;i<node.getNumberOfParents();i++)
			if (node.getParentAt(i)==((TreeTrace)trace).getRoot())
				counter++;
			else 
				counter+=countNodes(node.getParentAt(i));
		return counter;
	}
	
//	private void count(Node node,boolean apply)
//	{
//	   for(int i = 0; i < node.getNumberOfChildren(); i++)
//	   {
//		  Node child = (Node)node.getChildAt(i);
//		  if (node.isHidden()==apply)
//		  	counter++;
//		  }
//		  else
//		  {
//			  remove(child,apply);	
//		  }	
//	   }	
//	}
	/**
	 * @return
	 */
	public Hashtable getJavaClasses() {
		return javaClasses;
	}

}