/*****************************************************************
 * Tool: SEAT - Software Exploration and Analysis Tool			 *
 *																 *
 * Class: PrivateMethodsRemovalAlgorithm.java					 *	
 * Package: algorithms										     *
 *																 *
 * @author: Abdelwahab Hamou-Lhadj								 *
 *																 *	
 * Affiliation: Knowledge Based Reverse Engineering Group		 *
 *				SITE - University of Ottawa						 *
 *																 *
 * @version: 1.0 - July 2003									 *
 * 																 *
 * Modifications: 												 *
 * (please add date of modifications and author after this line) *	
 *																 *
 *****************************************************************/
 
package seat.model.algorithms;

import java.util.Hashtable;

import seat.model.core.dynamic.Node;
import seat.model.core.dynamic.Trace;
import seat.model.core.dynamic.TreeTrace;
import seat.model.core.structure.MethodElement;
import seat.ui.algorithm.ICompressNode;
// May 5, 2004 Eric, for all algorithms that need to process single node, implements ICompressNode
// All algorithms will be modified to have inherited two methods apply(Trace trace)/undo(Trace trace).
// So those two interfaces are added, previuos process interface is keeped.    

public class PrivateMethodsRemovalAlgorithm extends Removal implements ICompressNode
{ 
  private Hashtable dup = new Hashtable();
  
  /** Creates an object of PrivateMethodsRemoval
   * 
   * @param trace method invocation trace to be processed
   *
   */
   
  public void apply(Trace trace)
  {
	// dup.clear();
	Node node=((TreeTrace)trace).getRoot();
	 remove(node,true);
  }

  public void undo(Trace trace)
  {
	// dup.clear();
	Node node=((TreeTrace)trace).getRoot();
	 remove(node,false);
  }  
  
  public void process(Node node)
  {
	// dup.clear();
	 remove(node,true);
  }

  public void unprocess(Node node)
  {
	// dup.clear();
	 remove(node,false);
  }

  private static void remove(Node node,boolean apply)
  {
 	 for(int i = 0; i < node.getNumberOfChildren(); i++)
 	 {
 		Node child = (Node)node.getChildAt(i);
 		
 		MethodElement methElem = (MethodElement)child.getBehaviouralElement();
 	
 		if (methElem.PRIVATE == true)
 	    {	
 	      /*  if (!dup.containsKey(methElem.getName()))
 	        {
 	        	System.out.println(methElem.getSignature());
 	        	dup.put(methElem.getName(), "");
 	        }
 	      */  
		  if (apply)
		   child.hide(index);
		   else 
		   child.show(index);
 		}
 		else
 		{
 			remove(child,apply);	
 		}	
 	 }	
  }


}