/*****************************************************************
 * Tool: SEAT - Software Exploration and Analysis Tool			 *
 *																 *
 * Class: RemoveRepetitions.java							 	 *	
 * Package: algorithms										     *
 *																 *
 * @author: Abdelwahab Hamou-Lhadj								 *
 *																 *	
 * Affiliation: Knowledge Based Reverse Engineering Group		 *
 *				SITE - University of Ottawa						 *
 *																 *
 * @version: 1.0 - July 2003									 *
 * 																 *
 * Modifications: 												 *
 * (please add date of modifications and author after this line) *	
 *																 *
 *****************************************************************/
 
package seat.model.algorithms;

import seat.model.core.dynamic.Edge;
import seat.model.core.dynamic.Node;
import seat.model.core.dynamic.Trace;
import seat.model.core.dynamic.TreeTrace;
import seat.ui.algorithm.ICompressNode;

// not used, bug in getEdge, combiend with IgnoreRep

//May 5, 2004 Eric, for all algorithms that need to process single node, implements ICompressNode
//All algorithms will be modified to have inherited two methods apply(Trace trace)/undo(Trace trace).
//So those two interfaces are added, previuos process interface is keeped.    
public class RemoveRepetitions extends Algorithm implements ICompressNode
{

  /**
   * @param node node that will undergo the changes 
   */
// first three methods are added in May 5,2004    
  public void apply(Trace trace)
  {
	// dup.clear();
	Node node=((TreeTrace)trace).getRoot();
	 process(node);
  }   
  public void undo(Trace trace)
	{
	}

  public void unprocess(Node node)
	{
	}

  
  
  // This algorithm is not used becasue the bug of getEdge(Edge) method
  // Eric Jun 2004
  
  public void process(Node node)
  {
   int i;
   int size;
   Node current;
   Node previous;
   
   if (node.isLeaf())
   		return;
   
   previous = (Node)node.getChildAt(0);
   size = node.getNumberOfChildren();
   i = 1;
   
   while (i < size)
   {
   	  current = (Node)node.getChildAt(i);
   	  
 	  if (current.getCertificate() == previous.getCertificate() &&
 	      current != previous)
   	  {	
   	  	Edge edge = node.getEdge(previous);
   	  	edge.setNumberOfRepetitions(edge.getNumberOfRepetitions() + 1);
   	  	
   	  	node.removeChild(current);
   	  	size--;
   	  }	
   	  else
   	  {
   	  	previous = current;
   	  	i++;	
   	  }	
   }
  }

}