/*****************************************************************
 * Tool: SEAT - Software Exploration and Analysis Tool			 *
 *																 *
 * Class: TreeBasedAlgorithm.java							 	 *	
 * Package: algorithms										     *
 *																 *
 * @author: Abdelwahab Hamou-Lhadj								 *
 *																 *	
 * Affiliation: Knowledge Based Reverse Engineering Group		 *
 *				SITE - University of Ottawa						 *
 *																 *
 * @version: 1.0 - July 2003									 *
 * 																 *
 * Modifications: 												 *
 * (please add date of modifications and author after this line) *	
 *																 *
 *****************************************************************/
 
package seat.model.algorithms;

import seat.model.core.dynamic.Node;

public abstract class TreeBasedAlgorithm extends Algorithm
{
  /** Creates an object of TreeBasedAlgorithm
   * 
   * @param trace tree based trace to be processed
   *
   */
   
  public TreeBasedAlgorithm()
  {}
    
  /** Processes the traces depending on the applied algorithm. This method needs to be
   * overriden.
   * 
   * @param node node that will undergo the changes 
   */
    
  public abstract void process(Node node);
}
