/*****************************************************************
 * Tool: SEAT - Software Exploration and Analysis Tool			 *
 *																 *
 * Class: MethodInvocationTrace.java							 *	
 * Package: core.dynamic										 *
 *																 *
 * @author: Abdelwahab Hamou-Lhadj								 *
 *																 *	
 * Affiliation: Knowledge Based Reverse Engineering Group		 *
 *				SITE - University of Ottawa						 *
 *																 *
 * @version: 1.0 - July 2003									 *
 * 																 *
 * Modifications: 												 *
 * (please add date of modifications and author after this line) *	
 *																 *
 *****************************************************************/

package seat.model.core.dynamic;

import java.io.IOException;
import java.util.Arrays;
import java.util.Collection;
import java.util.Comparator;

import seat.io.ITraceSource;
import seat.io.MethodInvocationTraceLoader;
import seat.ui.algorithm.JavaParsing;

public class MethodInvocationTrace extends RoutineCallTrace
{
  /** Creates a method invocation trace
   *
   * @param scenario the system scenario that corresponds to this trace
   * @param file source file of this trace
   *
   */
    
  public MethodInvocationTrace(Scenario scenario, ITraceSource source) 
  {
  	super(scenario, source);
  }
  
  /** Loads the trace into memory. */
    
   // Add more for gathing state information
  public void open() throws IOException
  {
	long startTime=0,endTime=0;
	startTime = System.currentTimeMillis();

	// original loading 
  	MethodInvocationTraceLoader loader = new MethodInvocationTraceLoader(this);
  	loader.open();
  	// ennd original
  	
	endTime = System.currentTimeMillis();
	state.setLoadTime((float)((endTime - startTime)/1000.0));
	state.setGraphSize(loader.getUniuqeNodes());
	Collection c=loader.getNodes();
	Node[] nodes=(Node[])c.toArray(new Node[c.size()]);
	Comparator comp=new Comparator() {
		public int compare(Object o1,Object o2) {
			return ((Node)o1).getLabel().compareTo(((Node)o2).getLabel());
		}
	};
	Arrays.sort(nodes,comp);
	for (int i=0;i<nodes.length;i++) {
		state.getNodeFinalList().add(nodes[i]);
		state.getNodeList().add(nodes[i]);
	}
//	JavaParsing jp=new JavaParsing(this);
//	jp.setPackageClassRelation(); 
  }
}