/*****************************************************************
 * Tool: SEAT - Software Exploration and Analysis Tool			 *
 *																 *
 * Class: SourceFile.java										 *	
 *																 *
 * @author: Abdelwahab Hamou-Lhadj								 *
 *																 *	
 * Affiliation: Knowledge Based Reverse Engineering Group		 *
 *				SITE - University of Ottawa						 *
 *																 *
 * @version: 1.0 - July 2003									 *
 * 																 *
 * Modifications: 												 *
 * (please add date of modifications and author after this line) *	
 *																 *
 *****************************************************************/
 
package seat.model.core.structure;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

import seat.io.*;



// May 5,2004, changed from SourceFile, to reflect general source of trace,
// Especially stream. So it nolonger extends File
public class StreamSource extends TraceSource
{
  	
  /** Creates a source file object
   * 
   * @param filePath file path
   *
   */
  private InputStream input; // added on May5,2004
  
  public StreamSource(String filePath)
  { 	
  	super(filePath,ITraceSource.PERSISTENT);  // add to init super class
  	try {
 		input=new FileInputStream(filePath);
  	} catch (FileNotFoundException fne) {
  		System.out.println("File not found: "+filePath);
  	}
  }

//added on May5,2004
  public StreamSource(InputStream in, String name, int type)
  { 
  	super(name,type);	
	input=in;
  }
//added on May5,2004
 public InputStream getStream() {
 	return input;
 }
 
 
	/* (non-Javadoc)
	 * @see seat.model.core.dynamic.ITraceSource#close()
	 */
	public void close() {
		// TODO Auto-generated method stub
		try {
			input.close();
		} catch (IOException ioe) {
			System.out.println("Failed to close the stream: "+ input.toString());
		}
	}

}
