/*
 * Created on May 4, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package seat.ui.algorithm;

import seat.SeatUtil;


/**
 * @author lfu
 *
 * Conveneice class to represent several algorithm as a whole.
 * Status of each algorithm that if it's applied to given trace
 * is also recorded inside.
 */
public class AlgorithmList {
	AlgorithmDescription[] algorithms;
	boolean[] status;   // status(applied to current trace or not)
	/**
	 * 
	 */
	public AlgorithmList() {
		super();
		// TODO Auto-generated constructor stub
		algorithms=AlgorithmDescription.findAll(SeatUtil.ALGORITHM_EXTENSION_POINT);
		status=new boolean[algorithms.length];
		for (int i=0;i<status.length;i++)
			status[i]=false;
	}
	
	/**
	 * @return
	 */
	public static AlgorithmDescription[] getAlgorithmDescriptions() {
		return AlgorithmDescription.findAll(SeatUtil.ALGORITHM_EXTENSION_POINT);
	}

	/** 
	 * find an algorithm description from an index
	 * Return null if not found.
	 * @param index
	 * @return
	 */
	public static AlgorithmDescription getAlgorithmDescription(String index) {
		AlgorithmDescription[] ad=AlgorithmDescription.findAll(SeatUtil.ALGORITHM_EXTENSION_POINT);
		for (int i=0;i<ad.length;i++) {
			if (ad[i].getIndex().equals(index))
				return ad[i];
		}
		return null; 
	}
	
//	public int getAlgorithmIndex(String id) {
//		for (int i=0;i<algorithms.length;i++) {
//			if (algorithms[i].getID().equals(id))
//				return i;
//		}
//		return -1;
//	}

	public boolean getAlgorithmStatus(String index) {
		for (int i=0;i<algorithms.length;i++) {
			if (algorithms[i].getIndex().equals(index))
				return status[i];
		}
		return false;
	}

	public void setAlgorithmStatus(String index,boolean stat) {
		for (int i=0;i<algorithms.length;i++) {
			if (algorithms[i].getIndex().equals(index))
				status[i]=stat;
		}
	}
	
//	public int getNumOfAlgorithmDescription() {
//		return algorithms.length;
//	}

}
