/*
 * Created on May 24, 2004
 * The JavaParsing use JDT core to parse required java classes for trace. The input project list are
 * use provided selectinos from UI. Therefore, the parsinf sholud be invoked after UI view/editor is up running. 
 */
package seat.ui.algorithm;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;

import org.eclipse.core.resources.IContainer;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.core.runtime.Path;
import org.eclipse.jdt.core.Flags;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.IMember;
import org.eclipse.jdt.core.IMethod;
import org.eclipse.jdt.core.IParent;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.ITypeHierarchy;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.JavaModelException;

import seat.SeatUtil;
import seat.model.core.dynamic.Node;
import seat.model.core.dynamic.Trace;
import seat.model.core.structure.ClassElement;
import seat.model.core.structure.LogicalPackage;
import seat.model.core.structure.MethodElement;

/**
 * @author lfu
 * The current parsing relies on where source projects are located and associated with current trace.
 * This impl of JavaParsing uses project list saved in SeatExtra class which temporarily in SeatPlugin.
 * 
 */
public class JavaParsing implements IParsing {
	private Trace trace;
	private IProject[] sourceProjects;
	private IProject activeProject;
	private Hashtable classElements=new Hashtable(); // used to establish inheritance relation
	private Hashtable javaClasses;  // for JavaElements from java core parsing
	
	/**
	 * 
	 */
	class ParserThread extends Thread {
		
			/* (non-Javadoc)
		 * @see java.lang.Runnable#run()
		 */
		public void run() {
			// TODO Auto-generated method stub
//			super.run();
			long startTime=0,endTime=0;
			startTime = System.currentTimeMillis();
			setPackageClassRelation();
			setClassHierarchy();
			setClassIsInterface();
			setMethodAttribute();	   	
			endTime = System.currentTimeMillis();
			trace.getState().setLoadTime(trace.getState().getLoadTime()+(float)((endTime - startTime)/1000.0));				
		}
	}
	
	public JavaParsing(Trace trace) {
		super();
		// TODO Auto-generated constructor stub
		this.trace=trace;
		this.activeProject=trace.getState().getActiveProject();
		this.sourceProjects=trace.getState().getProjects();
		if (this.sourceProjects==null)
			this.sourceProjects=new IProject[0];
		javaClasses=trace.getState().getJavaClasses();
	}

	public void parse() {
		ParserThread pt=new ParserThread();
		pt.start();
				
// This is the way if the new thread needs to call something in the UI		
//		Display.getDefault ().asyncExec (new Runnable () {
//		   public void run () {
//				long startTime=0,endTime=0;
//				startTime = System.currentTimeMillis();
//				setPackageClassRelation();
//				setClassHierarchy();
//				setClassIsInterface();
//				setMethodAttribute();	   	
//				endTime = System.currentTimeMillis();
//				trace.getState().setLoadTime(trace.getState().getLoadTime()+(float)((endTime - startTime)/1000.0));				
//		   }
//		});
	}
	/* (non-Javadoc)
	 * @see seat.ui.algorithm.IParsing#setPackageClassRelation()
	 */
	public void setPackageClassRelation() {
		// TODO Auto-generated method stub
		Hashtable pck=new Hashtable();
		Hashtable cls=new Hashtable();

		ArrayList nl=trace.getState().getNodeFinalList();
		String prevPckClass="";
		String pckClassName,lpn,lcn;
		int lastDot=-1;
		for (int i=0;i<nl.size();i++) {
			Node node=(Node)nl.get(i);
			pckClassName=NameParsing.getLongClassName(node);
			if (!pckClassName.equals(prevPckClass)) {
				// this is a new name set package/class relation
				lpn=NameParsing.getLongPckageName(node);
				lcn=NameParsing.getLongClassName(node);
				if (!lpn.equals("") && !lcn.equals("")) { // no bad data
					// set package/class
					LogicalPackage lp;
					lp=(LogicalPackage)pck.get(lpn);
					if (lp==null) {
						lp=new LogicalPackage(trace.getScenario().getSystem(),lpn);
						pck.put(lpn,lp); // cache package
					}
					ClassElement ce=((MethodElement)node.getBehaviouralElement()).getClassElement();
					ce.setPackage(lp);
					cls.put(lcn,ce);  // cache class
					classElements.put(ce.getName(),ce); // name as the key,add for later process
				}
			}
			prevPckClass=pckClassName;
		}
		
		ArrayList pl=trace.getState().getPackageList();
		pl.addAll(pck.keySet());
		ArrayList cl=trace.getState().getClassList();
		cl.addAll(cls.keySet());				
		//At the end of this method, classElements hashtable is filled for setClassHierarchy() method
	}

	/* (non-Javadoc)
	 * @see seat.ui.algorithm.IParsing#setClassHierarchy()
	 */
	public void setClassHierarchy() {
		// TODO Auto-generated method stub
		String extension="java";
		Enumeration en=classElements.elements();
		while (en.hasMoreElements()) {
			ClassElement ce=(ClassElement)en.nextElement();
			IJavaElement element=this.createFromName(ce.getName(),extension);
			if ( (element != null) && (element instanceof IMember)) {
				javaClasses.put(ce.getName(),element); // save for later setMethodAttributes
				ICompilationUnit cu= ((IMember) element).getCompilationUnit();
				if (cu != null && cu.isWorkingCopy()) {
					element= cu.getOriginal(element);
					if (element.getElementType() == IJavaElement.TYPE) {
						IType type= (IType) element;
						try {
							ce.setInterfaceFlag(type.isInterface());
							ITypeHierarchy fHierarchy= type.newTypeHierarchy(new NullProgressMonitor());
							IType[] supers=fHierarchy.getAllSuperclasses(type);
							for (int k=0;k<supers.length;k++) {
								ClassElement sup=(ClassElement)classElements.get(supers[k].getFullyQualifiedName());
								if (sup!=null) // some may not be parsed, like Object, ignore them
									ce.addSuperclass(sup);
							}
						} catch (JavaModelException jme) {}
					}
				}
			}						
		} // while
		//At the end of this method, javaClasses hashtable is filled for setMethodsAttribute() method
	}

	/* (non-Javadoc)
	 * @see seat.ui.algorithm.IParsing#setClassIsInterface()
	 */
	public void setClassIsInterface() {
		// TODO Auto-generated method stub
		// Do nothing here , work is done in setClassHierarchy(), line: 
		// ce[i].setInterfaceFlag(type.isInterface());

	}

	/* (non-Javadoc)
	 * @see seat.ui.algorithm.IParsing#setMethodAttribute()
	 */
	public void setMethodAttribute() {
		// TODO Auto-generated method stub
		ArrayList nl=trace.getState().getNodeFinalList();
		Node node=null;
		String longClassName=null,methodName;
		IParent je=null;
		for (int i=0;i<nl.size();i++) {
			node=(Node)nl.get(i);
			longClassName=NameParsing.getLongClassName(node);
			methodName=NameParsing.getShortMethodName(node);
			
			// the following code converts <init> to constructor-class name
			if (methodName.equalsIgnoreCase("<init>"))
				methodName=NameParsing.getShortClassName(node);
				
			je=(IParent)javaClasses.get(longClassName);
			if (je==null) // in case error
				continue;
			try { 
				IJavaElement[] children=je.getChildren();
				for (int k=0;k<children.length;k++) {
					IJavaElement child=children[k];
					if (child.getElementName().equals(methodName) &&(child.getElementType()==IJavaElement.METHOD) ) {
						IMethod method=(IMethod)child;
						int flag=method.getFlags();
						MethodElement me=(MethodElement)node.getBehaviouralElement();
						me.ABSTRACT=Flags.isAbstract(flag);
						me.FINAL=Flags.isFinal(flag);
						me.PRIVATE=Flags.isPrivate(flag);
						me.PROTECTED=Flags.isProtected(flag);
						me.PUBLIC=Flags.isPublic(flag);
						me.STATIC=Flags.isStatic(flag);
						me.setConstructorFlag(((IMethod)child).isConstructor());
						me.setDescription(JavaDocAccess.getJavaDocTextString(method,true));
					}
				}
			} catch (JavaModelException jme) {
				SeatUtil.showMessage("Error occurredd when parsing Jva source code!");
			}
		}	
			
	}
	
	private String getMethodComment(Node node) {
		String longClassName=NameParsing.getLongClassName(node);
		String methodName=NameParsing.getShortMethodName(node);
		IParent je=(IParent)javaClasses.get(longClassName);
		if (je!=null) { // in case error
			try { 
				IJavaElement[] children=je.getChildren();
				for (int k=0;k<children.length;k++) {
					IJavaElement child=children[k];
					if (child.getElementName().equals(methodName) &&(child.getElementType()==IJavaElement.METHOD) ) {
						IMethod method=((IMethod)child);
						return JavaDocAccess.getJavaDocTextString(method,true);
					}
				}
			} catch (JavaModelException jme) {
				SeatUtil.showMessage("Error occurredd when parsing Jva source code!");
			}
		}
		return ""; 
	}
//	public void parse(String fullClassName) {
//		IRunnableWithProgress op= new IRunnableWithProgress() {
//			public void run(IProgressMonitor pm) throws InvocationTargetException {
//				try {
//					doHierarchyRefresh(element, pm);
//				} catch (JavaModelException e) {
//					throw new InvocationTargetException(e);
//				}
//			}
//		};
//		
//		
//	}	
//	public void parse(String className,String methodName,IFile duplicate) {	
//		ICompilationUnit unit=JavaCore.createCompilationUnitFrom(duplicate);
//		try {
//		IJavaElement fInput=(IJavaElement)unit.getWorkingCopy();
//
//		if (fInput instanceof IParent) {
//			IParent classFile= (IParent) fInput;
//			IJavaElement[] javaElements=classFile.getChildren();
//			for (int j=0;j<javaElements.length;j++)
//				if (javaElements[j].getElementName().equals(className)) {
//					IParent topLevel= (IParent) javaElements[j];
//					IJavaElement[] children=topLevel.getChildren();
//										for (int i=0;i<children.length;i++) {
//											if (children[i].getElementName().equals(methodName) &&(children[i].getElementType()==IJavaElement.METHOD) ) {
//												IMethod method=(IMethod)children[i]; 
//												break;
//										}
//				}
//		}
//		}
//		} catch(JavaModelException jme) {}
//
//	}

	/**
	 * Creates the IJaveElement from the given class name.
	 * ClassName includes packge.class, e,g, org.eclipse.ui.Control.
	 * @param fullClassName as above,
	 * @param extension, here is 'java', not dot before java
	 * @return null if no JavaElement can be created(no source)
	 */
	private IJavaElement createFromName(String pckClassName,String extension) {
		String pn=pckClassName.replace('.','/');
		Path p=new Path(pn);
		p=(Path)p.addFileExtension("java");

		IWorkspaceRoot root=ResourcesPlugin.getWorkspace().getRoot();
		IResource project=root.findMember(activeProject.getFullPath());
		IFile file=((IContainer)project).getFile(p);
		boolean found =false;
		if (file.exists())
			found =true;
		else { // look into project list
			for (int i=0;i<sourceProjects.length;i++) {
//				if (sourceProjects[i].getNature()) // use proejct nature to test later on
				project=root.findMember(sourceProjects[i].getFullPath());
				file=((IContainer)project).getFile(p);
				if (file.exists()) {
					found=true;
					break;				
				}
			}				
		}
		if (!found)
			return null;

		// creates and get SourceType from file: top level element
		try {
			ICompilationUnit unit=JavaCore.createCompilationUnitFrom(file);
			IJavaElement fInput=(IJavaElement)unit.getWorkingCopy();
			if (fInput instanceof IParent) {
				IParent classFile= (IParent) fInput;
				IJavaElement[] javaElements=classFile.getChildren();
				String className=NameParsing.getShortClassName(pckClassName);
				for (int j=0;j<javaElements.length;j++)
					if (javaElements[j].getElementName().equals(className)) 
						return javaElements[j];
			}
		} catch(JavaModelException jme) {}
		return null;						
	}

//	// Parses all the package name from package.class,method name string
//	private String getLongPckageName(Node node) {
//		String fullQualifiedName=node.getLabel();
//		int lastDot=fullQualifiedName.lastIndexOf('.');
//		if (lastDot==-1) {
//			System.out.println("Bad data format for names(no dot): "+fullQualifiedName);
//			return "";
//		} else {
//			//separate
//			String qualifier=fullQualifiedName.substring(0,lastDot); // pck+class
//			lastDot=qualifier.lastIndexOf('.');
//			if (lastDot==-1) { // no pckage info
//				System.out.println("Bad data format for names(no dot): "+fullQualifiedName);
//				return "";
//			} else {
//				return qualifier.substring(0,lastDot);
//			}
//		}
//	}
//	
//	// Parses long class name from package.class.method name string
//	private String getLongClassName(Node node) {
//		String fullQualifiedName=node.getLabel();
//		int lastDot=fullQualifiedName.lastIndexOf('.');
//		if (lastDot==-1) {
//			System.out.println("Bad data format in java parsing(no dot): "+fullQualifiedName);
//			return ""; // bad data 
//		} else 	//separate
//			return fullQualifiedName.substring(0,lastDot);
//	}	
//
//
//	// Parses long class name from package.class.method name string
//	private String getShortClassName(Node node) {
//		String fullQualifiedName=node.getLabel();
//		int lastDot=fullQualifiedName.lastIndexOf('.');
//		if (lastDot==-1) {
//			System.out.println("Bad data format in java parsing(no dot): "+fullQualifiedName);
//			return ""; // bad data 
//		} else 	{ //separate
//			String qualifier=fullQualifiedName.substring(0,lastDot); // pck+class
//			lastDot=qualifier.lastIndexOf('.');
//			if (lastDot==-1) { // no pckage info
//				System.out.println("Bad data format for names(no dot): "+fullQualifiedName);
//				return "";
//			} else {
//				return qualifier.substring(lastDot+1);
//			}
//		}
//	}	
//
//	// Parse only classnmae form pck.Class name string
//	private String getShortClassName(String qualifier) {
//		int lastDot=qualifier.lastIndexOf('.');
//		String cn=null;
//		if (lastDot==-1) { // no pckage info
//			cn=qualifier; 
//		} else {
//			cn=qualifier.substring(lastDot+1);
//		}
//		return cn;	
//	}
//
//	// Parses long class name from package.class.method name string
//	private String getShortMethodName(Node node) {
//		String fullQualifiedName=node.getLabel();
//		int lastDot=fullQualifiedName.lastIndexOf('.');
//		if (lastDot==-1) {
//			System.out.println("Bad data format in java parsing(no dot): "+fullQualifiedName);
//			return ""; // bad data 
//		} else 	{ //separate
//				return fullQualifiedName.substring(lastDot+1);
//		}
//	}	
//	
	
}