/*
 * Created on Aug 6, 2003
 *
 * This class represents a parameter for an algoirthm in the plugin.xml
 * configuration file. A parameter can be set by Preference page.
 * Possible types are from FieldEditor package. 
 * @author lfu
 * @see org.eclipse.jface.preference.FieldEditor
 */
package seat.ui.algorithm;

/**
 */
public class Parameter {
	private String name;
	private String id;
	private String type;
	private String defaultData;
	private String current;
	/**
	 * Constructor.
	 */ 
	public Parameter(String n,String i,String t,String d) {
		super();
		// TODO Auto-generated constructor stub
		name=n;
		id=i;
		type=t;
		defaultData=d;
		current=d;
	}

	/**
	 * Returns the name of the parameter.
	 * @return
	 */
	public String getName() {
		return name;
	}

	/**
	 * Returns the ID of the parameter.
	 * @return
	 */
	public String getID() {
		return id;
	}

	/**
	 * Returns the type of the parameter
	 * @return type string
	 */
	public String getType() {
		return type;
	}
	
	
	/**
	 * Returns the initial default data for this parameter
	 * @return String
	 */
	public String getDefaultData() {
		return defaultData;
	}

	/**
	 * @return
	 */
	public String getCurrent() {
		return current;
	}

	/**
	 * @param string
	 */
	public void setCurrent(String string) {
		current = string;
	}

}
