/*
 * Created on May 21, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package seat.ui.tree;


import java.util.List;

import seat.model.core.dynamic.Node;
import seat.model.core.dynamic.Trace;

/**
 * @author lfu
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public interface ITreeNode {
	// For tree structure
	public ITreeNode getParent();       // required by tree struct in eclipse 
	public ITreeNode[] getChildren();   // as above
	public boolean hasChildren();		// as above
	
	// utility
	public void addChild(ITreeNode child);	// add a child node for current
	public void setParent(ITreeNode parent);// set parent for current
	public void setNode(Node node); // change the underlyign model node without a 'new'  
	public void clearChildren();			// remove all children	
	public ITreeNode getNextSibling();		// for searching
	public ITreeNode getPrevSibling();		// for searching
	public int  getRepetition();			// get repetitions that a parent calls this node
//	public void setRepetition();			// set new repetitions for display
	public void setTrace(Trace trace);   	// trace will be normally a static class attribute 
	public Trace getTrace(); 			  	// get static trace-set/gettrace will be removed if not needed in property page
	public void setElement(Node node);		// get data associate with it
	public Node getElement();				// get data associate with it
	public void setImageID(int id);			// a UI image 
	public int  getImageID(); 
	public void setColor(int colorID);		// colored for an image 
	public int  getColor(); 
	public boolean inside(List list);     	// if it's in a given list
	public void addRepModifier(int modi);   // modifier added to the basic repetition
	public void setHidden(boolean hidden);
	public boolean isHidden();
	
	// for display
	public String getName();
	public String getFullQualifiedName();
	public String getType();
	public String getScope();
	public int    getNumOfChildren();
	public int    getLevelOfCall();
	public String getDescription();		
	public void   setDescription(String desc);		
}
