/*
 * Created on May 4, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package seat.ui.tree;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IMarker;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IMenuListener;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.jface.action.Separator;
import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.jface.util.PropertyChangeEvent;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorSite;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.dialogs.PropertyDialogAction;
import org.eclipse.ui.part.EditorPart;
import org.eclipse.ui.part.FileEditorInput;

import seat.SeatPlugin;
import seat.SeatUtil;
import seat.io.ITraceSource;
import seat.model.algorithms.Algorithm;
import seat.model.core.dynamic.MethodInvocationTrace;
import seat.model.core.dynamic.Node;
import seat.model.core.dynamic.Scenario;
import seat.model.core.dynamic.Trace;
import seat.model.core.structure.SoftwareSystem;
import seat.model.core.structure.StreamSource;
import seat.ui.algorithm.AlgorithmDescription;
import seat.ui.algorithm.AlgorithmList;
import seat.ui.algorithm.GlobalUtilityFilter;
import seat.ui.algorithm.ICompressNode;
import seat.ui.algorithm.JavaParsing;
import seat.ui.algorithm.Parameter;
import seat.ui.views.FilterAction;
import seat.ui.views.FilterView;
import seat.ui.views.MultiActionContributor;
import seat.ui.views.PatternView;
import seat.ui.views.UtilityPreference;
import seat.ui.views.UtilityView;

/**
 * @author lfu
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class TraceEditor extends EditorPart implements ITraceEditor {
	protected TraceViewer pviewer;
//	Node root;
	private InputStream traceStream;
	private IFile traceFile;
//	private JavaParsing jp;
	private Action[] algActions;
	private PropertyDialogAction propertyAction;
	private MarkUtilityAction utilityAction; 
	private FilterAction filterAction; 
	private Action patternAction; 
	protected String titlePreffix="";

	// two auxilray view	
	private UtilityView utilView;  // will be set when view starts
	private PatternView patternView;
	private FilterView  filterView;

	private IPropertyChangeListener seatPrefListener =
		new IPropertyChangeListener() {
			/** Implementation of IPropertyChangeListener interface. So the editor will
			 * listen to the property changes. 
			 * @param event
			 */
			public void propertyChange(PropertyChangeEvent event) {
				// TODO Auto-generated method stub
				String property=event.getProperty();
				if (property.equals(SeatUtil.TRACE_SHOWFILTERED)) {
					pviewer.refreshViewerWithReload(); 		
				} else if (property.equals(SeatUtil.TRACE_ENABLED_DECORATORS)) {
//					DecorationPreference.updateCachedPreference(SeatUtil.TRACE_ENABLED_DECORATORS,event.getNewValue());
					pviewer.refreshViewer(); 		
				} else if (property.equals(SeatUtil.TRACE_LONG_DECORATION)) {
//					DecorationPreference.updateCachedPreference(SeatUtil.TRACE_LONG_DECORATION,event.getNewValue());
					pviewer.refreshViewer(); 					 			
				} else if (property.equals(SeatUtil.TRACE_DECORATION)) {
//					DecorationPreference.updateCachedPreference(SeatUtil.TRACE_DECORATION,event.getNewValue());
					pviewer.refreshViewer(); 					 
				} else if (property.equals(SeatUtil.TRACE_HIDDEN_FLAG)) { 
//					DecorationPreference.updateCachedPreference(SeatUtil.TRACE_HIDDEN_FLAG,event.getNewValue());
					pviewer.refreshViewer(); 		
				} else if (property.equals(SeatUtil.TRACE_UTILITY_METHODLIST)) {
//					UtilityPreference.updateCachedPreference(SeatUtil.TRACE_UTILITY_METHODLIST,event.getNewValue()); 
					UtilityPreference.filterUserUtility(pviewer.trace);
					pviewer.refreshViewer();			
				} else { // process for algoirthm parameter change			
					processAlgorithmPropertyChange(property);			
				}
			}
	};


	/**
	 * 
	 */
	public TraceEditor() {
		super();
		// TODO Auto-generated constructor stub
	}

	class CompressAction extends Action {
		private AlgorithmDescription algorithmDesc;
		
		public CompressAction(AlgorithmDescription alg) {
			super("",Action.AS_UNSPECIFIED);
			algorithmDesc=alg;
			setText(alg.getName());
			setImageDescriptor(SeatUtil.getImageDescriptor(alg.getIcon()));
		}
		public void run() {
			if (pviewer==null)
				return;

			IStructuredSelection selection=(IStructuredSelection)pviewer.getSelection();
			if (selection==null)
				return;
			Object current=selection.getFirstElement();
			Algorithm algorithm=algorithmDesc.createAlgorithm();		
			if ((current!=null)&& (current instanceof ITreeNode) && algorithm instanceof ICompressNode) {
				Node node=((ITreeNode)current).getElement();
				
				Parameter[] paras=algorithmDesc.getParameters();
				for (int i=1;i<paras.length;i++) { // o is for internal index
					paras[i].setCurrent(SeatUtil.getStringSetting(paras[i].getID()));
				}
				algorithm.init(paras);	// prepare and set parameters for compress.process/unprocess	
				ICompressNode compress=(ICompressNode)algorithm;
				if (!node.isHidden()) 
					compress.process(node);
				else 
					compress.unprocess(node);
				pviewer.refreshViewer();
				SeatUtil.refreshStatisViewIfOpened();
			}					
		}				
	}

	
	class MarkUtilityAction extends Action {

		public MarkUtilityAction() {
			// TODO Auto-generated constructor stub
			super("",Action.AS_PUSH_BUTTON);
			setText("Mark as Utility Method");
			setToolTipText("Mark as Utility Method");
			setImageDescriptor(SeatUtil.getImageDescriptor("icons/utility.gif"));
		}

		/* (non-Javadoc)
		 * @see org.eclipse.jface.action.IAction#run()
		 */
		public void run() {
			IStructuredSelection selection=(IStructuredSelection)pviewer.getSelection();
			ITreeNode[] paths=new ITreeNode[selection.size()];
			paths=(ITreeNode[])selection.toList().toArray(paths);
			ArrayList util=getUtilityList();
			for (int i=0;i<paths.length;i++) {
				if ( (paths[i]!=null)&&(!paths[i].inside(util)) ) {
					Node n=paths[i].getElement();
					util.add(n);	
					n.hide(SeatUtil.RESERVED_ALGIDX_UTILITY);			
					if (utilView!=null)
						utilView.addRow(n);					
				}
			}
			if (utilView!=null)
				utilView.updateTitle(util.size());
			pviewer.refreshIconOnly(paths); // update all icons with these name
			SeatUtil.refreshStatisViewIfOpened();
		}
	}		

//	class FilterAction extends Action {
//
//		public FilterAction() {
//			// TODO Auto-generated constructor stub
//			super("",Action.AS_PUSH_BUTTON);
//			setText("Filter This Node");
//			setToolTipText("Filter This Node");
//			setImageDescriptor(SeatUtil.getImageDescriptor("icons/fields_co.gif"));
//		}
//
//		/* (non-Javadoc)
//		 * @see org.eclipse.jface.action.IAction#run()
//		 */
//		public void run() {
//			IStructuredSelection selection=(IStructuredSelection)pviewer.getSelection();
//			ITreeNode[] paths=new ITreeNode[selection.size()];
//			paths=(ITreeNode[])selection.toList().toArray(paths);
//			Node[] nodes=new Node[paths.length];
//			for (int i=0;i<paths.length;i++)
//				nodes[i]=paths[i].getElement();
//			if (filterView!=null);
//				filterView.filterNode(nodes);
//		}
//	}	
	/* (non-Javadoc)
	 * @see org.eclipse.ui.ISaveablePart#doSave(org.eclipse.core.runtime.IProgressMonitor)
	 */
	public void doSave(IProgressMonitor monitor) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.ISaveablePart#doSaveAs()
	 */
	public void doSaveAs() {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IEditorPart#gotoMarker(org.eclipse.core.resources.IMarker)
	 */
	public void gotoMarker(IMarker marker) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IEditorPart#init(org.eclipse.ui.IEditorSite, org.eclipse.ui.IEditorInput)
	 */
	public void init(IEditorSite site, IEditorInput input)
		throws PartInitException {
		// TODO Auto-generated method stub
		setInput(input);
		setSite(site);
		traceFile=((FileEditorInput)input).getFile();
		try { 
			traceStream=traceFile.getContents();
		} catch (CoreException ce) {
			SeatUtil.showMessage("Cannot open the resource!");
		}
		setTitleImage(PlatformUI.getWorkbench().getSharedImages().getImage(ISharedImages.IMG_OBJ_ELEMENT));
		// prefernce init
		SeatPlugin.getDefault().getPreferenceStore().addPropertyChangeListener(seatPrefListener);
		PlatformUI.getWorkbench().getPreferenceStore().addPropertyChangeListener(seatPrefListener);

	}
	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchPart#dispose()
	 */
	public void dispose() {
		// TODO Auto-generated method stub
		SeatPlugin.getDefault().getPreferenceStore().removePropertyChangeListener(seatPrefListener);
		PlatformUI.getWorkbench().getPreferenceStore().removePropertyChangeListener(seatPrefListener);
		super.dispose();		
	}
	/* (non-Javadoc)
	 * @see org.eclipse.ui.ISaveablePart#isDirty()
	 */
	public boolean isDirty() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.ISaveablePart#isSaveAsAllowed()
	 */
	public boolean isSaveAsAllowed() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchPart#createPartControl(org.eclipse.swt.widgets.Composite)
	 */
	public void createPartControl(Composite parent) {
		// TODO Auto-generated method stub
		Trace trace=loadMethodInvocationTrace(traceStream,traceFile.getName());
		trace.getState().setType(SeatPlugin.getDefault().getExtra().traceType);
		trace.getState().setProjects(SeatPlugin.getDefault().getExtra().traceSourceProjects);
		GlobalUtilityFilter guf=new GlobalUtilityFilter();
		guf.apply(trace);
		pviewer=createAndSetViewer(parent,trace);
		if (traceFile!=null) {
			pviewer.setActiveProject(traceFile.getProject());
			trace.getState().setActiveProject(traceFile.getProject());
		}
		JavaParsing jp=new JavaParsing(trace);  //parsing java source
		jp.parse();
		
		
		// for property page to work
		getSite().setSelectionProvider(pviewer);
		// add right click support
		hookContextMenu();
		createFilterView();

		this.setTitle(titlePreffix+trace.getTraceSource().getName());
		pviewer.refreshViewer();
		}
		


	public abstract TraceViewer createAndSetViewer(Composite parent,Trace trace);
	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchPart#setFocus()
	 */
	public void setFocus() {
		// TODO Auto-generated method stub
		pviewer.getControl().setFocus();

	}
	
	private void createFilterView() {
		IViewPart filter=SeatUtil.findView("seat.ui.views.FilterView");
		if ((filter!=null)&&(filter instanceof FilterView))  {
			filterView=(FilterView)filter;
			filterView.setEditor(this);
		}
	}
	
	private Trace loadMethodInvocationTrace(String fileName) {
		long startTime=0,endTime=0;
		startTime = System.currentTimeMillis();
			
		SoftwareSystem system=new SoftwareSystem("IDE","test ide for dev");
		Scenario sce=new Scenario(system,"Update Database"); 
		MethodInvocationTrace trace=new MethodInvocationTrace(sce,new StreamSource(fileName));
		try {
			trace.open();				
		} catch (IOException ioe) {}

		endTime = System.currentTimeMillis();
		System.out.println("Trace(graph) load time: " + (endTime - startTime)/1000.0 +"sec");

		return trace;	
	}	
	private Trace loadMethodInvocationTrace(InputStream ins,String name) {
		try {
		long startTime=0,endTime=0;
		startTime = System.currentTimeMillis();
			
		SoftwareSystem system=new SoftwareSystem("IDE","test ide for dev");
		Scenario sce=new Scenario(system,"Update Database"); 
		MethodInvocationTrace trace=new MethodInvocationTrace(sce,new StreamSource(ins,name,ITraceSource.PERSISTENT));
		trace.open();				

		endTime = System.currentTimeMillis();
		System.out.println("Trace(graph) load time: " + (endTime - startTime)/1000.0 +"sec");
		return trace;	
		} catch (IOException ioe) {
			System.out.println("Failed to open trace");
			return null;
		}
	}	

	public Trace getTrace() {
		return pviewer.getTrace();
	}

	public ITraceViewer getActiveViewer() {
		return pviewer;
	}

	// private utility methods follow below
	private void createActions() {
		AlgorithmDescription[] ads=AlgorithmList.getAlgorithmDescriptions();
		algActions=new Action[ads.length];
		for (int i=0;i<ads.length;i++) { 
			algActions[i]=new CompressAction(ads[i]);
		}			
		
		utilityAction=new MarkUtilityAction(); 
		filterAction=new FilterAction(this);
		propertyAction = new PropertyDialogAction(TraceEditor.this.getSite().getShell(),pviewer);
		propertyAction.setText("Porperties");
		propertyAction.setToolTipText("Show detailed propertiess");
		propertyAction.setImageDescriptor(PlatformUI.getWorkbench().getSharedImages().
					getImageDescriptor(ISharedImages.IMG_OBJS_TASK_TSK));
		
	}
	private void hookContextMenu() {
		createActions();
		MenuManager menuMgr = new MenuManager("#PopupMenu");
		menuMgr.setRemoveAllWhenShown(true);
		menuMgr.addMenuListener(new IMenuListener() {
			public void menuAboutToShow(IMenuManager manager) {
				for (int i=0;i<algActions.length;i++) 
					manager.add(algActions[i]);	
				manager.add(new Separator());
				manager.add(utilityAction);
				manager.add(filterAction);
				manager.add(propertyAction);
				manager.add(new Separator("Additions"));						
			}
		});
		Menu menu = menuMgr.createContextMenu(pviewer.getControl());
		pviewer.getControl().setMenu(menu);
		getSite().registerContextMenu(menuMgr, pviewer);
	}
	
	// two convience methods, utility list and pattern lsit for the trace contained inside
	public ArrayList getUtilityList() {
		return pviewer.getTrace().getState().getUtilityList();
	}
	public ArrayList getPatternList() {
		return pviewer.getTrace().getState().getPatternList();
	}
	public ArrayList getFilterList() {
		return pviewer.getTrace().getState().getFilteredNodeList();
	}
	

	/** 
	 * Identify the algorithm this property belongs to by extract index from property.
	 * index@#@property. for all opened ITraceEditors, recall apply or undo with new parameter
	 */
	private void processAlgorithmPropertyChange(String property) {
		String index,prop;
		int sig=property.indexOf("@#@");
		if (sig==-1) // not a parameter 
			return;
			
		// reapply all algoirthms that are on because they may interfere with each other
		MultiActionContributor.reapplyAll();
//		index=property.substring(0,sig);
//		prop=property.substring(sig+3); // actuall not used, load from store
//
//		AlgorithmDescription algorithmDesc=AlgorithmList.getAlgorithmDescription(index);		
//		Parameter[] paras=algorithmDesc.getParameters();
//		for (int i=1;i<paras.length;i++) { // o is for internal index
//			paras[i].setCurrent(SeatUtil.getStringSetting(index+"@#@"+paras[i].getID()));
//		}			
//		Algorithm algorithm=algorithmDesc.createAlgorithm();		
//		algorithm.init(paras);		
//
//		IEditorReference[] refer=PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getEditorReferences();
//		Trace contained=null;
//		for (int i=0;i<refer.length;i++) {
//			IEditorPart ep=refer[i].getEditor(true);
//			if (ep instanceof ITraceEditor) {
//				ITraceViewer viewer=((ITraceEditor)ep).getViewer();
//				boolean algorthimApplied=viewer.getTrace().getState().getAlgorithmList().getAlgorithmStatus(index);
//				if (algorthimApplied) {
//					algorithm.undo(viewer.getTrace());
//					algorithm.apply(viewer.getTrace());
//				}
//			}
//		}
//		pviewer.refreshViewerWithReload();
	}
	
//	public void reapplyAllAlgorithms() {
////		IEditorReference[] refer=PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getEditorReferences();
////		Trace contained=null;
////		for (int i=0;i<refer.length;i++) {
////			IEditorPart ep=refer[i].getEditor(true);
////			if (ep instanceof ITraceEditor) {
////				ITraceViewer viewer=((ITraceEditor)ep).getViewer();
////				AlgorithmList al=viewer.getTrace().getState().getAlgorithmList();
////				for (int kk=0;kk<al.getNumOfAlgorithmDescription();kk++) {
////					boolean algorthimApplied=al.getAlgorithmStatus(kk);
////					if (algorthimApplied) {
////						algorithm.undo(viewer.getTrace());
////						algorithm.apply(viewer.getTrace());
////					}
////				}
////			}
////		}
//		
//	}
	/* (non-Javadoc)
	 * @see seat.ui.tree.ITraceEditor#getPatternView()
	 */
	public PatternView getPatternView() {
		// TODO Auto-generated method stub
		return patternView;
	}

	/* (non-Javadoc)
	 * @see seat.ui.tree.ITraceEditor#getUtilityView()
	 */
	public UtilityView getUtilityView() {
		// TODO Auto-generated method stub
		return utilView;
	}	

	/* (non-Javadoc)
	* @see seat.ui.tree.ITraceEditor#getUtilityView()
	*/
	public FilterView getFilterView() {	
	   // TODO Auto-generated method stub
	   return filterView;
   }	
	/* (non-Javadoc)
	 * @see seat.ui.tree.ITraceEditor#setPatternView(seat.ui.views.PatternView)
	 */
	public void setPatternView(PatternView pv) {
		// TODO Auto-generated method stub
		patternView=pv;
	}

	/* (non-Javadoc)
	 * @see seat.ui.tree.ITraceEditor#setUtilityView(seat.ui.views.UtilityView)
	 */
	public void setUtilityView(UtilityView uv) {
		// TODO Auto-generated method stub
		utilView=uv;
	}
	
//	public String getComment(Node node) {
//		return jp.getMethodComment(node);
//	}
	
}
