/*
 * Created on May 21, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package seat.ui.tree;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Map;

import org.eclipse.core.resources.IProject;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.viewers.IColorProvider;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;

import seat.SeatUtil;
import seat.model.core.dynamic.Node;
import seat.model.core.dynamic.PatternOccurrence;
import seat.model.core.dynamic.Trace;
import seat.ui.views.DecorationPreference;
import seat.ui.views.DecoratorOverlayIcon;
import seat.ui.views.UtilityPreference;
/**
 * @author lfu
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class TraceViewer extends TreeViewer implements ITraceViewer {
	protected Trace trace;
	protected ITraceTree tree;
	protected IProject activeProject;
	protected Color nodeBackground,defaultBackground; 
	protected ArrayList coloredItems;
//	colors[0]=new Color(display, new RGB(14,135,207));
//	colors[1]=new Color(display, new RGB(162,216,249));
//	colors[2]=new Color(display, new RGB(108,200,120));
//	colors[3]=new Color(display, new RGB(177,226,184));
//	colors[4]=new Color(display, new RGB(219,163,45));
//	colors[5]=new Color(display, new RGB(238,211,157));
//	colors[6]=new Color(display, new RGB(135,165,180));
//	colors[7]=new Color(display, new RGB(200,215,221));
	
	/**
	 * 
	 */
	public TraceViewer(Composite parent, Trace trace, int style) {
		super(parent,style);
		// TODO Auto-generated constructor stub
		this.trace=trace;
		this.tree=constructFromTrace(trace);

		this.setContentProvider(new TreeContentProvider());
		this.setLabelProvider(new TreeLabelProvider());
		this.setInput(tree.getInvisibleRoot()); // need set input to invisble , not starting

		nodeBackground=new Color(Display.getCurrent(), new RGB(162,216,249));
		defaultBackground=Display.getCurrent().getSystemColor(SWT.COLOR_WHITE);
		coloredItems=new ArrayList();
	}

	class TreeContentProvider implements IStructuredContentProvider,ITreeContentProvider {
		public void inputChanged(Viewer v, Object oldInput, Object newInput) {
		}
		public void dispose() {
		}
		public Object[] getElements(Object parent) {
			return getChildren(parent);
		}
		public Object getParent(Object child) {
			return ((ITreeNode) child).getParent();
		}
		public Object[] getChildren(Object parent) {
			return ((ITreeNode) parent).getChildren();
		}
		public boolean hasChildren(Object parent) {
			return ((ITreeNode) parent).hasChildren();
		}
	}

	// colors for color provider
	private static Color white=Display.getCurrent().getSystemColor(SWT.COLOR_WHITE);
	private static Color black=Display.getCurrent().getSystemColor(SWT.COLOR_BLACK);

	// Color usage is defined in SeatUtil color section	
	private static Color[] COLOR;
	static {
		COLOR=new Color[8];
		COLOR[0]=new Color(Display.getCurrent(), new RGB(162,216,249));
		COLOR[1]=new Color(Display.getCurrent(), new RGB(14,135,207));
		COLOR[2]=new Color(Display.getCurrent(), new RGB(108,200,120));
		COLOR[3]=new Color(Display.getCurrent(), new RGB(177,226,184));
		COLOR[4]=new Color(Display.getCurrent(), new RGB(219,163,45));
		COLOR[5]=new Color(Display.getCurrent(), new RGB(238,211,157));
		COLOR[6]=new Color(Display.getCurrent(), new RGB(135,165,180));
		COLOR[7]=new Color(Display.getCurrent(), new RGB(200,215,221));	
	}
	class TreeLabelProvider extends LabelProvider implements IColorProvider {
		private Map imageCache = new HashMap(11); // cache for performance
		public String getText(Object obj) {
			ITreeNode to=(ITreeNode)obj;			
			return DecorationPreference.decorate(to.getName(),to.getRepetition(),to.getElement().isHidden());
		}

		public Image getImage(Object obj) {
			String imageKey;
			if (obj instanceof ITreeNode) {
				ITreeNode path=(ITreeNode)obj;
				switch (path.getImageID()) {
					case SeatUtil.IMG_ROOT:
						imageKey="class_hi.gif";		
						break;
					case SeatUtil.IMG_CLASS:
						imageKey="class_obj.gif";		
						break;
					case SeatUtil.IMG_METHOD:
						imageKey="public_co.gif";		
						break;
					case SeatUtil.IMG_ALGORITHM1:
						imageKey="fields_co.gif";		
						break;
					case SeatUtil.IMG_UTILITY:
						imageKey="utility.gif";		
						break;
					case SeatUtil.IMG_PATTERN:
						imageKey="pattern.gif";		
						break;
					default:
						imageKey="fields_co.gif";		
						break;					
				}
			} else 
				imageKey="fields_co.gif";		
		
			ImageDescriptor descriptor = SeatUtil.getImageDescriptor("icons/"+imageKey);
			//obtain the cached image corresponding to the descriptor
			Image image = (Image)imageCache.get(descriptor);
			if (image == null) {
				image = descriptor.createImage();
				imageCache.put(descriptor, image);
			}		
			// we have get the base image so far
			
			ArrayList decors=new ArrayList();
			decors.add(null); 
			decors.add(SeatUtil.getImageDescriptor("icons/abstract_co.gif")); 
			DecoratorOverlayIcon overlayIcon = new DecoratorOverlayIcon(image, decors);
			Image newImage= (Image)imageCache.get(overlayIcon);
			if (newImage== null) {
				newImage= overlayIcon.createImage();
				imageCache.put(overlayIcon, newImage);
			}		
			
			return newImage;			
		}
		
		public Color getForeground(Object element) {
				return black; 			
		}
		public Color getBackground(Object element) {
			Node to=((ITreeNode)element).getElement();	
			Hashtable lastColored=tree.getLastColoredModelNode();
			if (lastColored.containsKey(to)) {
				int cid=((Integer)lastColored.get(to)).intValue();
				return COLOR[cid];
			} else 
				return white; 						 
		}
	
	}
	
//	// colors for color provider
//	private static Color white=Display.getCurrent().getSystemColor(SWT.COLOR_WHITE);
//	private static Color black=Display.getCurrent().getSystemColor(SWT.COLOR_BLACK);
//	private static Color color0=new Color(Display.getCurrent(), new RGB(14,135,207));
//	private static Color color1=new Color(Display.getCurrent(), new RGB(162,216,249));
//	private static Color color2=new Color(Display.getCurrent(), new RGB(108,200,120));
//	private static Color color3=new Color(Display.getCurrent(), new RGB(177,226,184));
//	private static Color color4=new Color(Display.getCurrent(), new RGB(219,163,45));
//	private static Color color5=new Color(Display.getCurrent(), new RGB(238,211,157));
//	private static Color color6=new Color(Display.getCurrent(), new RGB(135,165,180));
//	private static Color color7=new Color(Display.getCurrent(), new RGB(200,215,221));	
//
//	class TreeColorProvider implements IColorProvider {
//		public Color getForeground(Object element) {
//				return black; 			
//		}
//		public Color getBackground(Object element) {
//			ITreeNode to=(ITreeNode)element;
//			if (to.getColor()==1)
//				return color0;
//			else 
//				return white; 						 
//		}
//	}

	/* (non-Javadoc)
	 * @see seat.ui.viewer.ITraceViewer#refreshViewer()
	 */
	public void refreshViewer() {
		// TODO Auto-generated method stub
//		this.setImages();
		refreshViewer(this.tree.getStarting());
	}

	public abstract void refreshViewer(ITreeNode node);
	public abstract void refreshViewerWithReload();

	/* (non-Javadoc)
	 * @see seat.ui.viewer.ITraceViewer#refreshIconOnly()
	 */
	public void refreshIconOnly() {
		// TODO Auto-generated method stub
		this.setImages(); // reDetermine images
		Tree wt=(Tree)this.getControl();
		TreeItem[] mains=wt.getItems(); // multithread/mains
		for (int i=0;i<mains.length;i++) 
			refreshOneIcon(mains[i]);				
	}

	public void refreshIconOnly(ITreeNode[] paths) {
		this.setImages(); // reDetermine images
		Tree wt=(Tree)this.getControl();
		TreeItem[] mains=wt.getItems(); // multithread/mains
		for (int i=0;i<mains.length;i++) 
			refreshOneIcon(mains[i],paths);
	}
	
	private void refreshOneIcon(TreeItem item,Object[] paths) {
		if ((item==null)||(item.getData()==null))
			return;

		// update item if actually originated from same node
		Node it=((ITreeNode)item.getData()).getElement();
		for (int i=0;i<paths.length;i++) 
			if (((ITreeNode)paths[i]).getElement()==it) {
				this.updateItem(item,item.getData());
				break;
			}

		TreeItem[] children=item.getItems();
		for (int i=0;i<children.length;i++) {
			refreshOneIcon(children[i],paths); 
		}
	}

	private void refreshOneIcon(TreeItem item) {
		if ((item==null)||(item.getData()==null))
			return;

		// update item if actually originated from same node
		Node it=((ITreeNode)item.getData()).getElement();
		this.updateItem(item,item.getData());

		TreeItem[] children=item.getItems();
		for (int i=0;i<children.length;i++) {
			refreshOneIcon(children[i]); 
		}
	}	


//	public void refreshColorOnly(Node source) {		
//		for (int i=0;i<coloredItems.size();i++) {
//			TreeItem it=(TreeItem)coloredItems.get(i);
//			if (it!=null)
//				decolorizeItem(it);
//		}
//		coloredItems.clear();
//		
//		Tree wt=(Tree)this.getControl();
//		TreeItem[] mains=wt.getItems(); // multithread/mains
//		for (int i=0;i<mains.length;i++) 
//			refreshOneColor(mains[i],source);
//	}
	
//	private void refreshOneColor(TreeItem item,Node source) {
//		if ((item==null)||(item.getData()==null))
//			return;
//
//		// update item if actually originated from same node
//		ITreeNode itn=(ITreeNode)item.getData();
//		if (itn.getElement()==source) { // set color for this node and all its children
//			colorizeItem(item);
//			coloredItems.add(itn);
//		} 
//
//		if (!itn.getColored() && item.getItemCount()>0) { // no further for children if already one
//			TreeItem[] children=item.getItems();
//			for (int i=0;i<children.length;i++) {
//				refreshOneColor(children[i],source);
//			} 
//		}
//
//	}
//	
//	private void colorizeItem(TreeItem item) {
//		item.setBackground(nodeBackground);
//		((ITreeNode)item.getData()).setColored(true);				 
//		if (item.getItemCount()>0) {
//			TreeItem[] children=item.getItems();
//			for (int i=0;i<children.length;i++)
//				colorizeItem(children[i]);
//		}		
//	}
//	private void decolorizeItem(TreeItem item) {
//		item.setBackground(defaultBackground);
//		if (item.getData()==null)
//			return;
//		((ITreeNode)item.getData()).setColored(false);				 
//		if (item.getItemCount()>0) {
//			TreeItem[] children=item.getItems();
//			for (int i=0;i<children.length;i++)
//				decolorizeItem(children[i]);
//		}		
//	}

	/* (non-Javadoc)
	 * @see seat.ui.viewer.ITraceViewer#getTrace()
	 */
	public Trace getTrace() {
		// TODO Auto-generated method stub
		return trace;
	}

	public ITraceTree getTraceTree() { // construct UI tree	
		return tree;		
	} 

	protected abstract ITraceTree constructFromTrace(Trace trace); // construct UI tree

	/**
	 * Sets image ids for all node elements that is included in a trace
	 */
	protected void setImages() {	
		setImageHelper(tree.getStarting());		
	}
  
	// called by setImages
	private void setImageHelper(ITreeNode node) {
		if (node==null)
			return;
		determineImage(node);
		ITreeNode[] children=node.getChildren();
		for (int i=0;i<children.length;i++) {
			setImageHelper(children[i]);
		}
	}	
	
	// THIS IS THE METHOD THAT DETERMINES THE VISUALIZATION OF NODES OF TREE
	// The icon/image of node will be displayed using rule here 
	private void determineImage(ITreeNode tn) {
		Node model=tn.getElement();
		if (!model.isHidden()) {
			if (tn.equals(tree.getStarting()))
				tn.setImageID(SeatUtil.IMG_ROOT); 
			else if (tn.hasChildren())
				tn.setImageID(SeatUtil.IMG_CLASS);
			else  
				tn.setImageID(SeatUtil.IMG_METHOD);
				
			// Tests if in gobla permant utility list
			String ul=SeatUtil.getStringSetting(SeatUtil.TRACE_UTILITY_METHODLIST);
			if (ul.indexOf(tn.getElement().getLabel())!=-1) {
				tn.setImageID(SeatUtil.IMG_UTILITY);
			}
				
			// tests if in utility list
			ArrayList util=trace.getState().getUtilityList();
			Node node=tn.getElement();			
			for (int i=0;i<util.size();i++)
				if ((Node)util.get(i)==node) {
					tn.setImageID(SeatUtil.IMG_UTILITY);
					break;
				}

			// tests if in pattern list
			ArrayList pattern=trace.getState().getPatternList();
			for (int i=0;i<pattern.size();i++)
				if ((Node)pattern.get(i)==node) {
					tn.setImageID(SeatUtil.IMG_PATTERN);
					break;
				}	
											
		} else {
			tn.setImageID(SeatUtil.IMG_ALGORITHM1);			
		}
		if (tn.isHidden()) // ui level hiden,like ignore order merge
			tn.setImageID(SeatUtil.IMG_ALGORITHM1);				
	}
	
	/**
	 * Sets image ids for all node elements that is included in a trace
	 */
//	public void setColors(Node node,int colorID) {	
//		tree.setLastColoredModelNode(node);
//		setColorHelper(tree.getStarting(),node,colorID);		
//	}
//  
//	// called by setImages
//	private void setColorHelper(ITreeNode node,Node model,int colorID) {
//		if (node==null)
//			return;
//		if (node.getElement()==model) {
//			setNodeColor(node,colorID);
//			node.setColor(colorID);
//		} else { // do for the children of this node
//			if (node.getNumOfChildren()==0)
//				return;
//			ITreeNode[] children=node.getChildren();
//			for (int i=0;i<children.length;i++) {
//				setColorHelper(children[i],model,colorID);
//			} 			
//		}			
//	}		
//	
//	private void setNodeColor(ITreeNode node,int colorID) {
//		node.setColor(colorID);
//		if (node.getNumOfChildren()==0)
//			return;
//		ITreeNode[] children=node.getChildren();
//		for (int i=0;i<children.length;i++) {
//			children[i].setColor(colorID);
//		}
//	}
		
	
	public void setActiveProject(IProject prj) {
		activeProject=prj;
	}
	
	public IProject getActiveProject() {
		return activeProject; 
	}	
	
}
