/*
 * Created on May 21, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package seat.ui.tree.complete;

import java.util.Hashtable;

import seat.model.algorithms.IgnoreOrder;
import seat.model.core.dynamic.Node;
import seat.model.core.dynamic.Trace;
import seat.model.core.dynamic.TreeTrace;
import seat.ui.tree.ITreeNode;
import seat.ui.tree.TraceTree;
import seat.ui.tree.TreeNode;

/**
 * @author lfu
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class CompleteTree extends TraceTree {
	protected ITreeNode invisibleRoot;  
	/**
	 * @param trace
	 */
	public CompleteTree(Trace trace) {
		super(trace);
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see seat.ui.viewer.ITraceTree#construct()
	 */
	public ITreeNode construct() {
		// TODO Auto-generated method stub
		Node root=((TreeTrace)trace).getRoot();
		ITreeNode mian=new TreeNode(root);
		mian.setDescription("starting");
		mian.setTrace(trace);

		invisibleRoot=new TreeNode(root); // root of UI tree to be returned, it's the same path as starting
		invisibleRoot.setDescription("Invisible");
		invisibleRoot.addChild(mian);
		mian.setParent(invisibleRoot);		
		invisibleRoot.setTrace(trace);

		retrieveSubTree(mian);
		return mian;
	}

	private void retrieveSubTree(ITreeNode current) {
		ITreeNode parent=current,child=null;
		parent.clearChildren();
		Node node=current.getElement();
		int n=node.getNumberOfChildren();
		for (int i=0;i<n;i++) {
			child=new TreeNode(node.getChildAt(i));
			child.setTrace(trace);
			parent.addChild(child);  // link all other nodes except last one
			child.setParent(parent);
			retrieveSubTree(child);
			}
	}


	/* (non-Javadoc)
	 * @see seat.ui.tree.ITraceTree#getInvisibleRoot()
	 */
	public ITreeNode getInvisibleRoot() {
		// TODO Auto-generated method stub
		return invisibleRoot;
	}

	// used by igonreOrder algoirthm
	public void igonreOrder(boolean apply) {
		if (apply) {
			organise(getStarting());
			mergeChildren(getStarting());
		} else {
			unorganise(getStarting());
			unmergeChildren(getStarting());
		}
	}


	/**
	 * Similiar to retrieveSubTree, this mothod also retrieves subtree from template and
	 * adds it to toBeChanged.
	 * @param template: subtree to be copied from, do not include template(root)
	 * @param toBeChanged: parent to be added to from retrieve subtree
	 */
	private Hashtable changedNodes=new Hashtable();	
	public void organise(ITreeNode root) {
			ITreeNode[] children=root.getChildren();
			for (int i=0;i<children.length;i++) {
				ITreeNode child=children[i];
				if (child.getElement().getState()==1) { // igonre order
					changedNodes.put(child,child.getElement()); //cache for restore
					Node from=(Node)IgnoreOrder.table.get(child.getElement().computeSignature());
					changeOrder(child,from);
				}
				organise(child);
			}
	}
	
	public void unorganise(ITreeNode root) {
			ITreeNode[] children=root.getChildren();
			for (int i=0;i<children.length;i++) {
				ITreeNode child=children[i];
				if (changedNodes.containsKey(child)) {
					Node original=(Node)changedNodes.get(child);
					changeOrder(child,original);					
				}
				unorganise(child);
			}
	}
	
	public void changeOrder(ITreeNode toBeChanged, Node from) {
		ITreeNode[] oldChildren=toBeChanged.getChildren();
		int n=oldChildren.length;
		if (n!=from.getNumberOfChildren()) return;
		for (int i=0;i<n;i++) {
			ITreeNode child=oldChildren[i];
			child.setNode(from.getChildAt(i));
			changeOrder(child,from.getChildAt(i));
			}				
	}

	public void changeOrder_old(ITreeNode toBeChanged, Node from) {
		ITreeNode[] oldChildren=toBeChanged.getChildren();
		toBeChanged.clearChildren();
		Node node=from;
		int n=node.getNumberOfChildren();
		for (int i=0;i<n;i++) {
			ITreeNode child=new TreeNode(node.getChildAt(i));
			toBeChanged.addChild(child);  // link all other nodes except last one
			child.setParent(toBeChanged);
			retrieveSubTree(child);
			}				
	}
	
	// need to consider hidden scenario
	private void mergeChildren(ITreeNode node) {
		ITreeNode[] children=node.getChildren();
		int current=0,next=1;
		boolean currentProcessed=false;
		try {
			while (next<children.length) {
				if (!children[next].isHidden()&&!children[next].getElement().isHidden()) { 
					if (children[current].getElement().getCertificate()==children[next].getElement().getCertificate()) {
						children[current].addRepModifier(children[next].getRepetition());
						children[next].setHidden(true); 
						currentProcessed=true; 			
					}
					else {
						mergeChildren(children[current]);
						current=next;
						currentProcessed=false; 			
					}
				}
				next++;
			}
			if (!currentProcessed)
				mergeChildren(children[current]);		
		} catch (ArrayIndexOutOfBoundsException ae) {}
	}


	private void unmergeChildren(ITreeNode node) {
		ITreeNode[] children=node.getChildren();
		for (int i=0;i<children.length;i++) {
			children[i].addRepModifier(0);
			children[i].setHidden(false);
			unmergeChildren(children[i]);
		}
	}

}
