/*
 * Created on May 21, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package seat.ui.tree.complete;

import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerFilter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;

import seat.SeatUtil;
import seat.model.core.dynamic.Node;
import seat.model.core.dynamic.Trace;
import seat.ui.tree.ITraceTree;
import seat.ui.tree.ITreeNode;
import seat.ui.tree.TraceViewer;
import seat.ui.tree.partial.TreeDoubleClickListener;

/**
 * @author lfu
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class CompleteTreeViewer extends TraceViewer {
	private RefreshFilter refreshFilter=new RefreshFilter();

	/**
	 * @param parent
	 * @param trace
	 */
	public CompleteTreeViewer(Composite parent, Trace trace) {
		super(parent, trace,SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL);
		// TODO Auto-generated constructor stub		
		this.addDoubleClickListener(new TreeDoubleClickListener(this));
	}

	class RefreshFilter extends ViewerFilter {
		public boolean select(Viewer viewer,Object parentElement,Object element) {
			if (element instanceof ITreeNode) 
				return !((ITreeNode)element).getElement().isHidden()&&!((ITreeNode)element).isHidden();
			else
				return false;
		}
	}

	/* (non-Javadoc)
	 * @see seat.ui.viewer.ITraceViewer#refreshViewer(seat.ui.viewer.ITreeNode)
	 */
	public void refreshViewer(ITreeNode node) {
		// TODO Auto-generated method stub
		this.getControl().setRedraw(false);
		String filter=SeatUtil.getStringSetting(SeatUtil.TRACE_SHOWFILTERED);
		boolean includeFiltered=Boolean.valueOf(filter).booleanValue();
		if (includeFiltered)
			this.resetFilters();
			//removeFilter sometimes seems not working properly, replaced with clear
			//this.removeFilter(refreshFilter);
		else
			this.addFilter(refreshFilter);
		
		this.setImages();
		this.internalRefresh(this.tree.getStarting());
		this.getControl().setRedraw(true);
	}

	/* (non-Javadoc)
	 * @see seat.ui.viewer.ITraceViewer#refreshViewerWithReload()
	 */
	public void refreshViewerWithReload() {
		// TODO Auto-generated method stub
		refreshViewer();
	}

	/* (non-Javadoc)
	 * @see seat.ui.viewer.ITraceViewer#constructFromTrace(seat.model.core.dynamic.Trace)
	 */
	public ITraceTree constructFromTrace(Trace trace) {
		// TODO Auto-generated method stub		
		CompleteTree ct=new CompleteTree(trace);
		return ct;
	}


}
