/*
 * Created on Jun 16, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package seat.ui.tree.complete;

import java.io.IOException;
import java.io.InputStream;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IMarker;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.dialogs.ErrorDialog;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IEditorSite;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.FileEditorInput;
import org.eclipse.ui.part.MultiPageEditorPart;

import seat.SeatPlugin;
import seat.SeatUtil;
import seat.io.ITraceSource;
import seat.model.core.dynamic.MethodInvocationTrace;
import seat.model.core.dynamic.Node;
import seat.model.core.dynamic.Scenario;
import seat.model.core.dynamic.Trace;
import seat.model.core.structure.SoftwareSystem;
import seat.model.core.structure.StreamSource;
import seat.ui.algorithm.GlobalUtilityFilter;
import seat.ui.algorithm.JavaParsing;
import seat.ui.tree.ITraceEditor;
import seat.ui.tree.ITraceTree;
import seat.ui.tree.ITraceViewer;
import seat.ui.tree.TraceEditor2M;
import seat.ui.views.FilterView;
import seat.ui.views.PatternView;
import seat.ui.views.UtilityView;

/**
 * @author lfu
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MultiTraceEditor extends MultiPageEditorPart implements ITraceEditor{
//	private ArrayList exploration;
	private TraceEditor2M defEditor, extraEditor;
	private InputStream traceStream;
	private IFile traceFile;
	private Trace trace;
//	private JavaParsing jp;
	private int lastIndex=0;

	protected String titlePreffix="MultiPage: ";

	/**
	 * 
	 */
	public MultiTraceEditor() {
		super();
//		exploration=new ArrayList(4);
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.part.MultiPageEditorPart#createPages()
	 */
	protected void createPages() {
		// TODO Auto-generated method stub
		trace=loadTrace(); // must not be put in cosntructor, need prj infor from init
		defEditor = new CompleteTreeEditor2M(this,trace,true);
		extraEditor = new CompleteTreeEditor2M(this,trace,false);
		addNewExploration(defEditor);
		setActivePage(0);
//		try {
//			editor1 = new CompleteTreeEditor2M(this,trace);			
//			int index = addPage(editor1, getEditorInput());
//			editor2 = new CompleteTreeEditor2M(this,trace);			
//			index = addPage(editor2, getEditorInput());
//			setPageText(index, "Exploration 2"); 
//			editor3 = new CompleteTreeEditor2M(this,trace);			
//			index = addPage(editor3, getEditorInput());
//			setPageText(index, "Exploration 3"); 
//			setActivePage(0);
//		}
//		catch (PartInitException e) {
//			ErrorDialog.openError(getSite().getShell(), "Cannot create multiple editors", null, e.getStatus()); //$NON-NLS-1$
//		}
		this.setTitle(titlePreffix+trace.getTraceSource().getName());
	}

	public void addNewExploration() {
		addNewExploration(extraEditor);
	}
	
	public void delelteExploration() {
		//try {
			int act=getActivePage();
			setActivePage(0);
			if (act!=-1)
				removePage(act);
//		} catch (PartInitException e) {
//			ErrorDialog.openError(getSite().getShell(), "Cannot create multiple editors", null, e.getStatus()); //$NON-NLS-1$
//		}
	}
	private void addNewExploration(TraceEditor2M editor) {
		try {
//			TraceEditor2M editor = new CompleteTreeEditor2M(this,trace,def);
			int index= addPage(editor, getEditorInput());
			setPageText(index, "Exploration "+lastIndex);
			setActivePage(index);
			lastIndex++;				
//			exploration.add(editor); 
		} catch (PartInitException e) {
			ErrorDialog.openError(getSite().getShell(), "Cannot create multiple editors", null, e.getStatus()); //$NON-NLS-1$
		}
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.ui.ISaveablePart#doSave(org.eclipse.core.runtime.IProgressMonitor)
	 */
	public void doSave(IProgressMonitor monitor) {
		// TODO Auto-generated method stub
		getEditor(0).doSave(monitor);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.ISaveablePart#doSaveAs()
	 */
	public void doSaveAs() {
		// TODO Auto-generated method stub
		IEditorPart editor = getEditor(0);
		editor.doSaveAs();
		setPageText(0, editor.getTitle());
		setInput(editor.getEditorInput());
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IEditorPart#gotoMarker(org.eclipse.core.resources.IMarker)
	 */
	public void gotoMarker(IMarker marker) {
		// TODO Auto-generated method stub
		setActivePage(0);
		getEditor(0).gotoMarker(marker);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.ISaveablePart#isSaveAsAllowed()
	 */
	public boolean isSaveAsAllowed() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IEditorPart#init(org.eclipse.ui.IEditorSite, org.eclipse.ui.IEditorInput)
	 */
	public void init(IEditorSite site, IEditorInput input)
		throws PartInitException {
		// TODO Auto-generated method stub
		super.init(site, input);
		setInput(input);
		setSite(site);
		traceFile=((FileEditorInput)input).getFile();
		try { 
			traceStream=traceFile.getContents();
		} catch (CoreException ce) {
			SeatUtil.showMessage("Cannot open the resource!");
		}
		setTitleImage(PlatformUI.getWorkbench().getSharedImages().getImage(ISharedImages.IMG_OBJ_ELEMENT));
		// prefernce init
//		SeatPlugin.getDefault().getPreferenceStore().addPropertyChangeListener(seatPrefListener);
//		PlatformUI.getWorkbench().getPreferenceStore().addPropertyChangeListener(seatPrefListener);		
	}
	
	private Trace loadTrace() {
		Trace trace=loadMethodInvocationTrace(traceStream,traceFile.getName());
		trace.getState().setType(SeatPlugin.getDefault().getExtra().traceType);
		trace.getState().setProjects(SeatPlugin.getDefault().getExtra().traceSourceProjects);
		GlobalUtilityFilter guf=new GlobalUtilityFilter();
		guf.apply(trace);
		if (traceFile!=null) {
			trace.getState().setActiveProject(traceFile.getProject());
		}
		// Active project must be set before parsing
		JavaParsing jp=new JavaParsing(trace);  //parsing java source
		jp.parse();
		return trace;
	}
	private Trace loadMethodInvocationTrace(String fileName) {
		long startTime=0,endTime=0;
		startTime = System.currentTimeMillis();
			
		SoftwareSystem system=new SoftwareSystem("IDE","test ide for dev");
		Scenario sce=new Scenario(system,"Update Database"); 
		MethodInvocationTrace trace=new MethodInvocationTrace(sce,new StreamSource(fileName));
		try {
			trace.open();				
		} catch (IOException ioe) {}

		endTime = System.currentTimeMillis();
		System.out.println("Trace(graph) load time: " + (endTime - startTime)/1000.0 +"sec");

		return trace;	
	}	
	private Trace loadMethodInvocationTrace(InputStream ins,String name) {
		try {
		long startTime=0,endTime=0;
		startTime = System.currentTimeMillis();
			
		SoftwareSystem system=new SoftwareSystem("IDE","test ide for dev");
		Scenario sce=new Scenario(system,"Update Database"); 
		MethodInvocationTrace trace=new MethodInvocationTrace(sce,new StreamSource(ins,name,ITraceSource.PERSISTENT));
		trace.open();				

		endTime = System.currentTimeMillis();
		System.out.println("Trace(graph) load time: " + (endTime - startTime)/1000.0 +"sec");
		return trace;	
		} catch (IOException ioe) {
			System.out.println("Failed to open trace");
			return null;
		}
	}			
	/* (non-Javadoc)
	 * @see seat.ui.tree.ITraceEditor#getPatternView()
	 */
	public PatternView getPatternView() {
		// TODO Auto-generated method stub
		return ((TraceEditor2M)getActiveEditor()).getPatternView();
	}

	/* (non-Javadoc)
	 * @see seat.ui.tree.ITraceEditor#getTrace()
	 */
	public Trace getTrace() {
		// TODO Auto-generated method stub
		return trace;
	}

	/* (non-Javadoc)
	 * @see seat.ui.tree.ITraceEditor#getUtilityView()
	 */
	public UtilityView getUtilityView() {
		// TODO Auto-generated method stub
		return ((TraceEditor2M)getActiveEditor()).getUtilityView();
	}



	/* (non-Javadoc)
	 * @see seat.ui.tree.ITraceEditor#setPatternView(seat.ui.views.PatternView)
	 */
	public void setPatternView(PatternView pv) {
		// TODO Auto-generated method stub
		for (int i=0;i<getPageCount();i++)
			((TraceEditor2M)getEditor(i)).setPatternView(pv);
	}

	/* (non-Javadoc)
	 * @see seat.ui.tree.ITraceEditor#setUtilityView(seat.ui.views.UtilityView)
	 */
	public void setUtilityView(UtilityView uv) {
		// TODO Auto-generated method stub
		for (int i=0;i<getPageCount();i++)
			((TraceEditor2M)getEditor(i)).setUtilityView(uv);
	}
	/* (non-Javadoc)
	 * @see seat.ui.tree.ITraceEditor#getViewer()
	 */
	public ITraceViewer getActiveViewer() {
		// TODO Auto-generated method stub
		return ((TraceEditor2M)getActiveEditor()).getViewer();
	}

	/* (non-Javadoc)
	 * @see seat.ui.tree.ITraceEditor#getTraceTree()
	 */
	public ITraceTree getTraceTree() {
		// TODO Auto-generated method stub
		return getActiveViewer().getTraceTree();
	}

	/* (non-Javadoc)
	 * @see seat.ui.tree.ITraceEditor#refreshIconOnly()
	 */
	public void refreshIconOnly() {
		// TODO Auto-generated method stub
		getActiveViewer().refreshIconOnly();
//		if (editor1.getViewer()!=null)
//			editor1.getViewer().refreshIconOnly();
//		if (editor2.getViewer()!=null)
//			editor2.getViewer().refreshIconOnly();
//		if (editor3.getViewer()!=null)
//			editor3.getViewer().refreshIconOnly();
	}

	/* (non-Javadoc)
	 * @see seat.ui.tree.ITraceEditor#refreshViewer()
	 */
	public void refreshViewer() {
		// TODO Auto-generated method stub
		getActiveViewer().refreshViewer();
//		if (editor1.getViewer()!=null)
//			editor1.getViewer().refreshViewer();
//		if (editor2.getViewer()!=null)
//			editor2.getViewer().refreshViewer();
//		if (editor3.getViewer()!=null)
//			editor3.getViewer().refreshViewer();
	}

	/* (non-Javadoc)
	 * @see seat.ui.tree.ITraceEditor#refreshViewerWithReload()
	 */
	public void refreshViewerWithReload() {
		// TODO Auto-generated method stub
		getActiveViewer().refreshViewerWithReload();
//		if (editor1.getViewer()!=null)
//			editor1.getViewer().refreshViewerWithReload();
//		if (editor2.getViewer()!=null)
//			editor2.getViewer().refreshViewerWithReload();
//		if (editor3.getViewer()!=null)
//			editor3.getViewer().refreshViewerWithReload();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.part.MultiPageEditorPart#pageChange(int)
	 */
	protected void pageChange(int newPageIndex) {
		// TODO Auto-generated method stub
		super.pageChange(newPageIndex);
		TraceEditor2M te=(TraceEditor2M)getEditor(newPageIndex);
		if (te.getViewer()!=null)
			te.getViewer().refreshViewer();
//		//test
//		try {
//			TraceEditor2M ed = new CompleteTreeEditor2M(this,trace);					
//			int index = addPage(ed, getEditorInput());
//			setPageText(index, "Exploration added"); 
//		} catch (PartInitException pie) {
//			SeatUtil.showMessage("Cannot create new editor!");
//			System.out.println("Cannot create new editor!");
//		}
	}
	
//	public String getComment(Node node) {
//		return jp.getMethodComment(node);
//	}
//	
	public FilterView getFilterView() {
		return ((TraceEditor2M)getActiveEditor()).getFilterView();
	}

}

