/*
 * Created on Jul 17, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package seat.ui.views;

import java.util.StringTokenizer;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.preference.StringFieldEditor;
import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.jface.util.PropertyChangeEvent;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.eclipse.ui.PlatformUI;

import seat.SeatPlugin;
import seat.SeatUtil;

/**
 * @author lfu
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class DecorationPreference
	extends FieldEditorPreferencePage
	implements IWorkbenchPreferencePage {
	
	private static final String ID="seat.ui.decorator.TraceLightDecorator";
	private BooleanFieldEditor showPck;
	private StringFieldEditor nf;
	private StringFieldEditor example;
	private StringFieldEditor hf;
	
	private IPropertyChangeListener decoratePrefListener =
		new IPropertyChangeListener() {
			/** Implementation of IPropertyChangeListener interface. Listen to Decorator on/off
			 */
			public void propertyChange(PropertyChangeEvent event) {
				// TODO Auto-generated method stub
				String property=event.getProperty();
				if (property.equals(SeatUtil.TRACE_ENABLED_DECORATORS)) {
//					String tld=(String)event.getNewValue();//PlatformUI.getWorkbench().getPreferenceStore().getString("ENABLED_DECORATORS");
					setEnablement();
				}
			}
	};
	
	
//	public static boolean isDecorateOn;
//	public static boolean useLongName;
//	public static String decor;
//	public static String hidden;
//	static {
//		// loading init setting
//		String decors=PlatformUI.getWorkbench().getPreferenceStore().getString("ENABLED_DECORATORS");
//		isDecorateOn=(decors.indexOf("seat.ui.decorator.TraceLightDecorator:true")!=-1)?true:false;
//		useLongName=SeatUtil.getBooleanSetting(SeatUtil.TRACE_LONG_DECORATION);
//		decor=SeatUtil.getStringSetting(SeatUtil.TRACE_DECORATION);
//		if (decor.equals(""))
//			decor=SeatUtil.getDefaultSetting(SeatUtil.TRACE_DECORATION);
//		hidden=SeatUtil.getStringSetting(SeatUtil.TRACE_HIDDEN_FLAG);
//		if (hidden.equals(""))
//			hidden=SeatUtil.getDefaultSetting(SeatUtil.TRACE_HIDDEN_FLAG);		
//	}
	/**
	 * @param arg0
	 */
	public DecorationPreference() {
		// TODO Auto-generated constructor stub
		super(FieldEditorPreferencePage.GRID);
		setPreferenceStore(SeatPlugin.getDefault().getPreferenceStore());
		setDescription("Label decoration for method names. The settings will be disabled if Trace Decoration in WorkBench-Label " +
			"Decoration is unselected.");
		setDefaultConfig(getPreferenceStore());		
		PlatformUI.getWorkbench().getPreferenceStore().addPropertyChangeListener(decoratePrefListener);		
	}
	
	protected void createFieldEditors() {
		// TODO Auto-generated method stub
		showPck=new BooleanFieldEditor(SeatUtil.TRACE_LONG_DECORATION,"Show Package and Class Name",getFieldEditorParent());
		nf=new StringFieldEditor(SeatUtil.TRACE_DECORATION,"Name format: ",getFieldEditorParent());
		example=new StringFieldEditor("temp","Example:",getFieldEditorParent());
		hf=new StringFieldEditor(SeatUtil.TRACE_HIDDEN_FLAG,"Hidden flag:",getFieldEditorParent());

		setEnablement();
		example.setEnabled(false,getFieldEditorParent());

		addField(showPck);
		addField(nf);
		addField(example);
		addField(hf);
	}
	
	public static void setDefaultConfig(IPreferenceStore store) {
		store.setDefault(SeatUtil.TRACE_LONG_DECORATION,true);
		store.setDefault(SeatUtil.TRACE_DECORATION,"{hidden_flag}{name} [{repetition}]");
		store.setDefault("temp","$seat.SeatUtil.findView [10]");
		store.setDefault(SeatUtil.TRACE_HIDDEN_FLAG,"$");
	}
	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	public void init(IWorkbench arg0) {
		// TODO Auto-generated method stub
	}
	
////	public static boolean isDecorateOn;
//	static {
//		IPreferenceStore store=PlatformUI.getWorkbench().getPreferenceStore();
//		String decors=store.getString("ENABLED_DECORATORS");
//		if (decors.indexOf("seat.ui.decorator.TraceLightDecorator:true")!=-1) { // decorate 
//			isDecorateOn=true;		
//		} else isDecorateOn=false;
//	}
	public static String decorate(String fullName, int rep,boolean hide) {
		boolean isDecorateOn;
		boolean useLongName;
		String decor;
		String hidden;
		// loading init setting
//		String decors=PlatformUI.getWorkbench().getPreferenceStore().getString(SeatUtil.TRACE_ENABLED_DECORATORS);
//		isDecorateOn=(decors.indexOf("seat.ui.decorator.TraceLightDecorator:true")!=-1)?true:false;
		isDecorateOn=isTraceDecorationOn();
		useLongName=SeatUtil.getBooleanSetting(SeatUtil.TRACE_LONG_DECORATION);
		decor=SeatUtil.getStringSetting(SeatUtil.TRACE_DECORATION);
		if (decor.equals(""))
			decor=SeatUtil.getDefaultSetting(SeatUtil.TRACE_DECORATION);
		hidden=SeatUtil.getStringSetting(SeatUtil.TRACE_HIDDEN_FLAG);
		if (hidden.equals(""))
			hidden=SeatUtil.getDefaultSetting(SeatUtil.TRACE_HIDDEN_FLAG);		
		
		if (!isDecorateOn) return fullName;
		String name;
		useLongName=SeatUtil.getBooleanSetting(SeatUtil.TRACE_LONG_DECORATION);
		if (useLongName)
			name=fullName;
		else {
			int lastDot=fullName.lastIndexOf(".");
			name=(lastDot==-1)?fullName:fullName.substring(lastDot+1);
		}
		StringTokenizer allTokens = new StringTokenizer(decor, "{}");
		StringBuffer sb=new StringBuffer("");
		String token;
		while(allTokens.hasMoreTokens()) {
			token=allTokens.nextToken();
			if (token.equals("hidden_flag")) {
				if (hide)
					sb.append(hidden);
			} else if (token.equals("name"))
				sb.append(name);
			else if (token.equals("repetition"))
				sb.append(rep+"");
			else 
				sb.append(token);
		}		
		return sb.toString();
	}

//	public static {
//		IPreferenceStore store=PlatformUI.getWorkbench().getPreferenceStore();
//		String decors=store.getString("ENABLED_DECORATORS");
//		if (decors.indexOf("seat.ui.decorator.TraceLightDecorator:true")!=-1) { // decorate 
//			isDecorateOn=true;		
//		} else isDecorateOn=false;
//	}

/************************88
 * Lastest comments for cachuing prefrence:
 * It seems that the platform will cache the preference in hashmap.
 * So in order to keep preference up to date, do NOT cahce them now.
 * Because before a preference page init, default cache will try to set some 
 * unsidired value, when apply button in prefren page clicked, but no data change, 
 * a property change event will not send and therefore the cahce will not be updated. 
 */


//	/**
//	 * This signature method is implmented by any of the Prefrence pages
//	 * which caches the prefrence settings of stores in memory for performance.
//	 * Cached settings need to be updated when a fire event occurrs.
//	 * Use case 3: cache load from store; events update cache; refresher uses cache 
//	 *
//	 */
//	public static void updateCachedPreference(String id,Object update) {
//		if (id.equals("ENABLED_DECORATORS")) {
//			String decors=(String)update;
//			isDecorateOn=(decors.indexOf("seat.ui.decorator.TraceLightDecorator:true")!=-1)?true:false;
//		} else if (id.equals(SeatUtil.TRACE_LONG_DECORATION)) {
//			useLongName=((Boolean)update).booleanValue();
//		} else if (id.equals(SeatUtil.TRACE_DECORATION)) {
//			decor=(String)update;
//		} else if (id.equals(SeatUtil.TRACE_HIDDEN_FLAG)) {
//			hidden=(String)update;
//		}
//	}
//	
//	public static Object getCachedPreference(String id) {
//		if (id.equals("ENABLED_DECORATORS")) {
//			return new Boolean(isDecorateOn);
//		} else if (id.equals(SeatUtil.TRACE_LONG_DECORATION)) {
//			return new Boolean(useLongName); 
//		} else if (id.equals(SeatUtil.TRACE_DECORATION)) {
//			return decor;
//		} else if (id.equals(SeatUtil.TRACE_HIDDEN_FLAG)) {
//			return hidden;
//		} else return null;
//	}	

	
	/* (non-Javadoc)
	 * @see org.eclipse.jface.dialogs.IDialogPage#dispose()
	 */
	public void dispose() {
		// TODO Auto-generated method stub
		super.dispose();
		PlatformUI.getWorkbench().getPreferenceStore().removePropertyChangeListener(decoratePrefListener);
	}
	
	private void setEnablement() {
		boolean isDecorateOn=isTraceDecorationOn();
//		boolean isDecorateOn=(decorString.indexOf("seat.ui.decorator.TraceLightDecorator:true")!=-1)?true:false;
		if (!isDecorateOn) {
			showPck.setEnabled(false,getFieldEditorParent());
			nf.setEnabled(false,getFieldEditorParent());
			hf.setEnabled(false,getFieldEditorParent());
		} else {
			showPck.setEnabled(true,getFieldEditorParent());
			nf.setEnabled(true,getFieldEditorParent());
			hf.setEnabled(true,getFieldEditorParent());
		}
	}
	
	public static boolean isTraceDecorationOn() {
		return PlatformUI.getWorkbench().getDecoratorManager().getEnabled(ID);
	}

	public static void setTraceDecoration(boolean status) {
		try {
			PlatformUI.getWorkbench().getDecoratorManager().setEnabled(ID,status);
		} catch (CoreException ce) {
			SeatUtil.showMessage("Trace decoration on/off can't be set!");
		}
	}
}
