/*
 * Created on Jun 16, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package seat.ui.views;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.jface.util.Assert;
import org.eclipse.ui.IActionBars;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IEditorReference;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.MultiPageEditorActionBarContributor;

import seat.SeatUtil;
import seat.io.TraceState;
import seat.ui.algorithm.AlgorithmDescription;
import seat.ui.algorithm.AlgorithmList;
import seat.ui.tree.ITraceEditor;

/**
 * @author lfu
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MultiActionContributor extends MultiPageEditorActionBarContributor {
		private static AlgorithmAction[] actions;
		private static AlgorithmDescription[] ads;
		/**
		 * 
		 */
		public MultiActionContributor() {
			super();
			// TODO Auto-generated constructor stub	
			if (actions==null) 				
				createActions();
		}
		private static void createActions() {
			ads=AlgorithmList.getAlgorithmDescriptions();
			actions=new AlgorithmAction[ads.length];
			for (int i=0;i<ads.length;i++) { 
				if (ads[i].getID().equals("seat.model.algorithms.DetectPatterns")) 
					actions[i]=new PatternAlgorithmAction(ads[i]);
				else if (ads[i].getID().equals("seat.model.algorithms.IgnoreOrder")) 
					actions[i]=new IgnoreOrderAlgorithmAction(ads[i]);
				else 
					actions[i]=new AlgorithmAction(ads[i]);			
			}				 
		}
		/* (non-Javadoc)
		 * @see org.eclipse.ui.part.EditorActionBarContributor#contributeToMenu(org.eclipse.jface.action.IMenuManager)
		 */
		public void contributeToMenu(IMenuManager menuManager) {
			// TODO Auto-generated method stub
			super.contributeToMenu(menuManager);
			IMenuManager compress = new MenuManager("Algorithms");
			menuManager.insertAfter("additions", compress); // addt additions group
			for (int i=0;i<actions.length;i++) 
				compress.add(actions[i]);	
		}

		/* (non-Javadoc)
		 * @see org.eclipse.ui.part.EditorActionBarContributor#contributeToToolBar(org.eclipse.jface.action.IToolBarManager)
		 */
		public void contributeToToolBar(IToolBarManager toolBarManager) {
			// TODO Auto-generated method stub
			super.contributeToToolBar(toolBarManager);
			for (int i=0;i<actions.length;i++) 
				toolBarManager.add(actions[i]);	
		}
	
		/**
		 * Returns all actions contained inside this contr, to be modified by editor
		 */
		public Action[] getAlgoirthmActions() {
			return actions;
		}
	

		/* (non-Javadoc)
		 * @see org.eclipse.ui.IEditorActionBarContributor#init(org.eclipse.ui.IActionBars, org.eclipse.ui.IWorkbenchPage)
		 */
		public void init(IActionBars bars, IWorkbenchPage page) {
			// TODO Auto-generated method stub
			super.init(bars, page);
			// There is no active editor at this step yet. Move code to setActiveEditor()
		}
	
		/** (non-Javadoc)
		 * Method declared on IEditorActionBarContributor, set check/uncheck status of tool bar
		 */
		public void setActiveEditor(IEditorPart editor) {
			// Run super.
			super.setActiveEditor(editor);
//			TraceState state;
			if (editor instanceof ITraceEditor) {
				TraceState state=((ITraceEditor)editor).getTrace().getState();
				if (state!=null) {			
					AlgorithmList al;
					for (int i=0;i<actions.length;i++) {
						al=state.getAlgorithmList();
			//			actions[i].setGroup(al);
						actions[i].setChecked(al.getAlgorithmStatus(ads[i].getIndex()));
					}		
				}
			}
		}
	
		public static void reapplyAll() {
			IEditorReference[] refer=PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().getEditorReferences();
			for (int i=0;i<refer.length;i++) {
				IEditorPart ep=refer[i].getEditor(true);
				if (ep instanceof ITraceEditor) {
					ITraceEditor tedit=(ITraceEditor)ep;
					if (actions==null) 				
						createActions();
					for (int kk=0;kk<actions.length;kk++) { // iterate all the actions
						AlgorithmAction act=actions[kk];
						act.core(tedit.getTrace(),true);
					} // for kk
					tedit.refreshViewerWithReload();
				}
			} // for i
			SeatUtil.refreshStatisViewIfOpened();
		}

		public static void reapply4CurrentEditor(AlgorithmAction except) {
			IEditorPart ep=SeatUtil.getActiveEditor();
			Assert.isNotNull(ep);
			if (ep instanceof ITraceEditor) {
				ITraceEditor tedit=(ITraceEditor)ep;
				if (actions==null) 
					createActions();
				for (int kk=0;kk<actions.length;kk++) { // iterate all the actions except the give current one
					if (actions[kk]!=except) 				
						actions[kk].core(tedit.getTrace(),true);
				} // for kk
				tedit.refreshViewerWithReload();			
			}
		}
	

	/* (non-Javadoc)
	 * @see org.eclipse.ui.part.MultiPageEditorActionBarContributor#setActivePage(org.eclipse.ui.IEditorPart)
	 */
	public void setActivePage(IEditorPart activeEditor) {
		// TODO Auto-generated method stub

	}

}
