/*
 * Created on Jun 1, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package seat.ui.views;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;

import org.eclipse.core.resources.IFile;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IMenuListener;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.jface.action.Separator;
import org.eclipse.jface.util.PropertyChangeEvent;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.IViewSite;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.dialogs.PropertyDialogAction;
import org.eclipse.ui.part.ViewPart;

import seat.SeatPlugin;
import seat.SeatUtil;
import seat.io.ITraceSource;
import seat.model.core.dynamic.MethodInvocationTrace;
import seat.model.core.dynamic.Scenario;
import seat.model.core.dynamic.Trace;
import seat.model.core.structure.SoftwareSystem;
import seat.model.core.structure.StreamSource;
import seat.ui.tree.ITraceViewer;
import seat.ui.tree.complete.CompleteTreeViewer;

	/**
	 * @author lfu
	 *
	 * To change the template for this generated type comment go to
	 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
	 */
public class TreeViewAll extends ViewPart {	
		private CompleteTreeViewer pviewer;
//		Node root;
		private InputStream startup;
		private IFile tr;

		private Action[] algActions;
		private PropertyDialogAction propertyAction;
//		private MarkUtilityAction utilityAction; 
//		private FilterAction filterAction; 
		private Action patternAction; 


		/**
		 * 
		 */
		public TreeViewAll() {
			super();
			// TODO Auto-generated constructor stub
		}



		/* (non-Javadoc)
		 * @see org.eclipse.ui.IWorkbenchPart#createPartControl(org.eclipse.swt.widgets.Composite)
		 */
		public void createPartControl(Composite parent) {
			// TODO Auto-generated method stub
			Trace trace=loadMethodInvocationTrace("H:\\partial.ctf");
			trace.getState().setType(SeatPlugin.getDefault().getExtra().traceType);
			trace.getState().setProjects(SeatPlugin.getDefault().getExtra().traceSourceProjects);
			this.setTitle(trace.getTraceSource().getName());
			pviewer=new CompleteTreeViewer(parent,trace);
		
			// for property page to work
			getSite().setSelectionProvider(pviewer);
			// add right click support
			hookContextMenu();
			}

		public void setFocus() {
			// TODO Auto-generated method stub
			if (pviewer.getControl()!=null)
				pviewer.getControl().setFocus();

		}
	
	
		private Trace loadMethodInvocationTrace(String fileName) {
			long startTime=0,endTime=0;
			startTime = System.currentTimeMillis();
			
			SoftwareSystem system=new SoftwareSystem("IDE","test ide for dev");
			Scenario sce=new Scenario(system,"Update Database"); 
			MethodInvocationTrace trace=new MethodInvocationTrace(sce,new StreamSource(fileName));
			try {
				trace.open();				
			} catch (IOException ioe) {}

			endTime = System.currentTimeMillis();
			System.out.println("Trace(graph) load time: " + (endTime - startTime)/1000.0 +"sec");

			return trace;	
		}	
		private Trace loadMethodInvocationTrace(InputStream ins,String name) {
			try {
			long startTime=0,endTime=0;
			startTime = System.currentTimeMillis();
			
			SoftwareSystem system=new SoftwareSystem("IDE","test ide for dev");
			Scenario sce=new Scenario(system,"Update Database"); 
			MethodInvocationTrace trace=new MethodInvocationTrace(sce,new StreamSource(ins,name,ITraceSource.PERSISTENT));
			trace.open();				

			endTime = System.currentTimeMillis();
			System.out.println("Trace(graph) load time: " + (endTime - startTime)/1000.0 +"sec");
			return trace;	
			} catch (IOException ioe) {
				System.out.println("Failed to open trace");
				return null;
			}
		}	

		public Trace getTrace() {
			return pviewer.getTrace();
		}

		public ITraceViewer getViewer() {
			return pviewer;
		}

		// private utility methods follow below
		private void createActions() {
//			AlgorithmDescription[] ads=AlgorithmList.getAlgorithms();
//			algActions=new Action[ads.length];
//			for (int i=0;i<ads.length;i++) { 
//				algActions[i]=new CompressAction(ads[i]);
//			}			
//		
//			utilityAction=new MarkUtilityAction(); 
//			filterAction=new FilterAction();
//			propertyAction = new PropertyDialogAction(TraceEditor.this.getSite().getShell(),pviewer);
//			propertyAction.setText("Porperties");
//			propertyAction.setToolTipText("Show detailed propertiess");
//			propertyAction.setImageDescriptor(PlatformUI.getWorkbench().getSharedImages().
//						getImageDescriptor(ISharedImages.IMG_OBJS_TASK_TSK));
		
		}
		private void hookContextMenu() {
			createActions();
			MenuManager menuMgr = new MenuManager("#PopupMenu");
			menuMgr.setRemoveAllWhenShown(true);
			menuMgr.addMenuListener(new IMenuListener() {
				public void menuAboutToShow(IMenuManager manager) {
					for (int i=0;i<algActions.length;i++) 
						manager.add(algActions[i]);	
					manager.add(new Separator());
//					manager.add(utilityAction);
//					manager.add(filterAction);
					manager.add(propertyAction);
					manager.add(new Separator("Additions"));						
				}
			});
			Menu menu = menuMgr.createContextMenu(pviewer.getControl());
			pviewer.getControl().setMenu(menu);
			getSite().registerContextMenu(menuMgr, pviewer);
		}
	
		// two convience methods, utility list and pattern lsit for the trace contained inside
		public ArrayList getUtilityList() {
			return pviewer.getTrace().getState().getUtilityList();
		}
		public ArrayList getPatternList() {
			return pviewer.getTrace().getState().getPatternList();
		}
		public ArrayList getFilterList() {
			return pviewer.getTrace().getState().getFilteredNodeList();
		}
	
		/** Implementation of IPropertyChangeListener interface. So the editor will
		 * listen to the property changes. 
		 * @param event
		 */
		public void propertyChange(PropertyChangeEvent event) {
			// TODO Auto-generated method stub
			String property=event.getProperty();
			if (property.equals(SeatUtil.TRACE_SHOWFILTERED)) {
				pviewer.refreshViewerWithReload(); 		
			}
			else if (property.equals(SeatUtil.TRACE_UTILITY_METHODLIST)) { 
			}
		}
		/* (non-Javadoc)
		 * @see seat.ui.tree.ITraceEditor#getPatternView()
		 */
//		public PatternView getPatternView() {
//			// TODO Auto-generated method stub
//			return patternView;
//		}
//
//		/* (non-Javadoc)
//		 * @see seat.ui.tree.ITraceEditor#getUtilityView()
//		 */
//		public UtilityView getUtilityView() {
//			// TODO Auto-generated method stub
//			return utilView;
//		}	
//		/* (non-Javadoc)
//		 * @see seat.ui.tree.ITraceEditor#setPatternView(seat.ui.views.PatternView)
//		 */
//		public void setPatternView(PatternView pv) {
//			// TODO Auto-generated method stub
//			patternView=pv;
//		}
//
//		/* (non-Javadoc)
//		 * @see seat.ui.tree.ITraceEditor#setUtilityView(seat.ui.views.UtilityView)
//		 */
//		public void setUtilityView(UtilityView uv) {
//			// TODO Auto-generated method stub
//			utilView=uv;
//		}
//	
		/* (non-Javadoc)
		 * @see org.eclipse.ui.IViewPart#init(org.eclipse.ui.IViewSite)
		 */
		public void init(IViewSite site) throws PartInitException {
			// TODO Auto-generated method stub
			super.init(site);
		}

		/* (non-Javadoc)
		 * @see org.eclipse.ui.IViewPart#saveState(org.eclipse.ui.IMemento)
		 */
		public void saveState(IMemento memento) {
			// TODO Auto-generated method stub
			super.saveState(memento);
		}

	}
	