package seat.ui.views;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PlatformUI;


/**
 * Class that provides labels and images for UniquePaths in the TreeView.
 * The labels are the names(method names) returned by getName().
 * Images are determined by the type of the UniquePath and can be customized
 * through preference page.
 * @author lfu
 * @see org.eclipse.jface.viewers.LabelProvider
 */
public class TreeViewLabelProvider2 extends LabelProvider {
	private Map imageCache = new HashMap(11); // cache for performance
	/**
	 * Return the text label of a UniquePath
	 */
	public String getText(Object obj) {
		TreeObject to=(TreeObject)obj;
			return to.getName();
	}

	/**
	 * Returns and caches the image. 
	 */
	public Image getImage(Object obj) {
		return PlatformUI.getWorkbench().
				getSharedImages().getImage(ISharedImages.IMG_OBJ_ELEMENT);
	}
	
}
